/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: dbg_cons.c,v 1.3 2006/02/07 10:12:14 abe Exp abe $
 */

/* 
 *  ǥХå󥽡
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <stdlib.h>

#include "../kernel/jsp_kernel.h"
#include "../kernel/task.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/net.h>
#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/ppp_var.h>
#include <net/ppp_fsm.h>
#include <net/ppp_lcp.h>
#include <net/ppp_ipcp.h>
#include <net/ppp_modem.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet6/nd6.h>
#include <netinet/if_ether.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>

#include <net/if_var.h>
#include <net/if6_var.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>
#include <netapp/discard.h>
#include <netapp/dbg_cons.h>

#ifdef USE_DBG_CONS

#define DBG_LINE_SIZE	63

/*
 *  task_status -- ξ֤ν
 */

static const char task_stat_str[][sizeof("SUSPENDED")] = {
	"DORMANT",		/* ٻ߾		*/
	"RUNNABLE",		/* ¹ԤǤ	*/
	"WAINTING",		/* Ԥ		*/
	"SUSPENDED",		/* Ԥ		*/
	"SLEEP",		/* Ԥ		*/
	"WOBJ",			/* Ʊ֥̿ȤФԤ	*/
	"WOBJCB",		/* ʬԤ塼ˤĤʤäƤ롣	*/
	};

static void
task_status (ID portid, UB *line)
{
	TCB	*tcb;
	int	ix, st, sx;

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "TASK Status\n"
	            "ID PI State\n");
	for (ix = TMIN_TSKID; ix <= tmax_tskid; ix ++) {
		tcb = get_tcb(ix);
		cons_printf(portid, "%2d %2d ", ix, tcb->priority);
		st = tcb->tstat;
		for (sx = 0; st; sx ++) {
			if (st & 0x01) {
				cons_printf(portid, "%s", task_stat_str[sx]);
				if (st & 0xfe)
					cons_printf(portid, "|");
				}
			st >>= 1;
			}
		cons_printf(portid, "\n");
		}

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#ifdef SUPPORT_TCP

/*
 *  tcp_status -- TCP ξ֤ν
 */

static const char tcp_fsm_str[][sizeof("ESTABLISHED")] = {
	"CLOSED",		/* 			*/
	"LISTEN",		/* ưץ			*/
	"SYN_SENT",		/* ǽưץSYN Ѥ	*/
	"SYN_RECVD",		/* ưץSYN Ѥ	*/
	"ESTABLISHED",		/* ͥߴλ		*/
	"CLOSE_WAIT",		/* ꤫ FIN APP νλԤ	*/
	"FIN_WAIT_1",		/* APP λFIN ѤߡACK Ԥ	*/
	"CLOSING",		/* ƱFIN 򴹺ѤߡACK Ԥ	*/
	"LAST_ACK",		/* APP λACK Ԥ			*/
	"FIN_WAIT_2",		/* ꤫ FIN Ԥ			*/
	"TIME_WAIT",		/* ꤫ FIN ѤߡԤ	*/
	};

#ifdef SUPPORT_INET4

static void
tcp_status (ID portid, UB *line)
{
	T_TCP_CCEP*	cep;
	UINT		len;

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

	T_TCP_TW_CCEP*	tw_cep;

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

#ifdef TCP_CFG_PASSIVE_OPEN

	T_TCP_CREP*	rep;
	int		cnt;

#endif	/* of #ifdef TCP_CFG_PASSIVE_OPEN */

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "TCP CEP Status\n"
	            "ID Snd-Q Rcv-Q Local Address         Foreign Address       State\n");

	for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++)
		if (cep->fsm_state == TCP_FSM_CLOSED) {
			cons_printf(portid,
			            "%2d     0     0"
			            " -                    "
			            " -                    "
			            " CLOSED\n",
			            GET_TCP_CCEPID(cep));
			}
		else if (cep->fsm_state == TCP_FSM_LISTEN) {
			cons_printf(portid, "%2d     0     0 ", GET_TCP_CCEPID(cep));
			len  = PUT_IPADDR(portid, &cep->myaddr.ipaddr, 0);
			cons_putchar(portid, ':');
			len += cons_putnumber(portid, cep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 20 - len; len -- > 0; )
				cons_putchar(portid, ' ');
			cons_printf(portid,
			            " -                    "
			            " LISTEN\n");
			}
		else {
			cons_printf(portid, "%2d %5d %5d ",
			            GET_TCP_CCEPID(cep), cep->swbuf_count, cep->rwbuf_count);
			len  = PUT_IPADDR(portid, &cep->myaddr.ipaddr, 0);
			cons_putchar(portid, ':');
			len += cons_putnumber(portid, cep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 21 - len; len -- > 0; )
				cons_putchar(portid, ' ');
			len  = PUT_IPADDR(portid, &cep->dstaddr.ipaddr, 0);
			cons_putchar(portid, ':');
			len += cons_putnumber(portid, cep->dstaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 20 - len; len -- > 0; )
				cons_putchar(portid, ' ');
			if (cep->fsm_state == TCP_FSM_TIME_WAIT)
				cons_printf(portid, " %s(%d)\n", tcp_fsm_str[cep->fsm_state],
				                    cep->timer[TCP_TIM_2MSL] / TCP_SLOW_HZ);
			else
				cons_printf(portid, " %s\n", tcp_fsm_str[cep->fsm_state]);
			}

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

	for (tw_cep = tcp_tw_ccep; tw_cep < &tcp_tw_ccep[NUM_TCP_TW_CEP_ENTRY]; tw_cep ++) {
		if (tw_cep->fsm_state == TCP_FSM_CLOSED) {
			cons_printf(portid,
			            "%2dTW   0     0"
			            " -                    "
			            " -                    "
			            " CLOSED\n",
			            GET_TCP_TW_CCEPID(tw_cep));
			}
		else {
			cons_printf(portid, "%2dTW   0     0 ", GET_TCP_TW_CCEPID(tw_cep));
			len  = PUT_IPADDR(portid, &tw_cep->myaddr.ipaddr, 0);
			cons_putchar(portid, ':');
			len += cons_putnumber(portid, tw_cep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 21 - len; len -- > 0; )
				cons_putchar(portid, ' ');
			len  = PUT_IPADDR(portid, &tw_cep->dstaddr.ipaddr, 0);
			cons_putchar(portid, ':');
			len += cons_putnumber(portid, tw_cep->dstaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 20 - len; len -- > 0; )
				cons_putchar(portid, ' ');
			if (tw_cep->fsm_state == TCP_FSM_TIME_WAIT)
				cons_printf(portid, " %s(%d)\n", tcp_fsm_str[tw_cep->fsm_state],
				                    tw_cep->timer_2msl / TCP_SLOW_HZ);
			else
				cons_printf(portid, " %s\n", tcp_fsm_str[tw_cep->fsm_state]);
			}
		}

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

#ifdef TCP_CFG_PASSIVE_OPEN

	cons_printf(portid,
	            "TCP REP Status\n"
	            "ID Local Address         CEP\n");
	for (rep = tcp_crep; rep < &tcp_crep[tmax_tcp_crepid]; rep ++) {
		cons_printf(portid, "%2d ", GET_TCP_CREPID(rep));
		len  = PUT_IPADDR(portid, &rep->myaddr.ipaddr, 0);
		cons_putchar(portid, ':');
		len += cons_putnumber(portid, rep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
		for (len = 21 - len; len -- > 0; )
			cons_putchar(portid, ' ');
		cnt = 0;
		for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++) {
			if (cep->rep == rep) {
				if (cnt > 0)
					cons_printf(portid, ",%d", GET_TCP_CCEPID(cep));
				else
					cons_printf(portid, "%d", GET_TCP_CCEPID(cep));
				cnt ++;
				}
			}
		cons_putchar(portid, '\n');
		}

#endif	/* of #ifdef TCP_CFG_PASSIVE_OPEN */

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

static void
tcp_status (ID portid, UB *line)
{
	T_TCP_CCEP*	cep;
	UINT		len;

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

	T_TCP_TW_CCEP*	tw_cep;

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

#ifdef TCP_CFG_PASSIVE_OPEN

	T_TCP_CREP*	rep;
	int		cnt;

#endif	/* of #ifdef TCP_CFG_PASSIVE_OPEN */

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "TCP CEP Status\n"
	            "ID Snd-Q Rcv-Q Foreign Address                             State\n");

	for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++)
		if (cep->fsm_state == TCP_FSM_CLOSED) {
			cons_printf(portid,
			            "%2d     0     0"
			            " -                                          "
			            " CLOSED\n",
			            GET_TCP_CCEPID(cep));
			}
		else if (cep->fsm_state == TCP_FSM_LISTEN) {
			cons_printf(portid, "%2d     0     0", GET_TCP_CCEPID(cep));
			cons_printf(portid,
			            " -                                          "
			            " LISTEN\n");
			}
		else {
			cons_printf(portid, "%2d %5d %5d ",
			            GET_TCP_CCEPID(cep), cep->swbuf_count, cep->rwbuf_count);
			len  = PUT_IPADDR(portid, &cep->dstaddr.ipaddr, 0);
			cons_putchar(portid, '.');
			len += cons_putnumber(portid, cep->dstaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 42 - len; len -- > 0; )
				cons_putchar(portid, ' ');
			if (cep->fsm_state == TCP_FSM_TIME_WAIT)
				cons_printf(portid, " %s(%d)\n", tcp_fsm_str[cep->fsm_state],
				                    cep->timer[TCP_TIM_2MSL] / TCP_SLOW_HZ);
			else
				cons_printf(portid, " %s\n", tcp_fsm_str[cep->fsm_state]);
			}

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

	for (tw_cep = tcp_tw_ccep; tw_cep < &tcp_tw_ccep[NUM_TCP_TW_CEP_ENTRY]; tw_cep ++) {
		if (tw_cep->fsm_state == TCP_FSM_CLOSED) {
			cons_printf(portid,
			            "%2dTW   0     0"
			            " -                                          "
			            " CLOSED\n",
			            GET_TCP_TW_CCEPID(tw_cep));
			}
		else {
			cons_printf(portid, "%2dTW   0     0 ", GET_TCP_TW_CCEPID(tw_cep));
			len  = PUT_IPADDR(portid, &tw_cep->dstaddr.ipaddr, 0);
			cons_putchar(portid, '.');
			len += cons_putnumber(portid, tw_cep->dstaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 42 - len; len -- > 0; )
				cons_putchar(portid, ' ');
			if (tw_cep->fsm_state == TCP_FSM_TIME_WAIT)
				cons_printf(portid, " %s(%d)\n", tcp_fsm_str[tw_cep->fsm_state],
				                    tw_cep->timer_2msl / TCP_SLOW_HZ);
			else
				cons_printf(portid, " %s\n", tcp_fsm_str[tw_cep->fsm_state]);
			}
		}

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

#ifdef TCP_CFG_PASSIVE_OPEN

	cons_printf(portid,
	            "TCP REP Status\n"
	            "ID Local Address         CEP\n");
	for (rep = tcp_crep; rep < &tcp_crep[tmax_tcp_crepid]; rep ++) {
		cons_printf(portid, "%2d ", GET_TCP_CREPID(rep));
		len  = PUT_IPADDR(portid, &rep->myaddr.ipaddr, 0);
		cons_putchar(portid, '.');
		len += cons_putnumber(portid, rep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
		for (len = 21 - len; len -- > 0; )
			cons_putchar(portid, ' ');
		cnt = 0;
		for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++) {
			if (cep->rep == rep) {
				if (cnt > 0)
					cons_printf(portid, ",%d", GET_TCP_CCEPID(cep));
				else
					cons_printf(portid, "%d", GET_TCP_CCEPID(cep));
				cnt ++;
				}
			}
		cons_putchar(portid, '\n');
		}

#endif	/* of #ifdef TCP_CFG_PASSIVE_OPEN */

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifdef SUPPORT_TCP */

#ifdef SUPPORT_ETHER

#ifdef SUPPORT_INET4

/*
 *  ifa_status -- ARP å
 */

static void
ifa_status (ID portid, UB *line)
{
	const T_ARP_ENTRY	*cache;
	int	ix;

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "ARP Cache\n"
	            "IX Expire IP Address      MAC Address\n");

	/* expire ñ̤ [ms]*/
	cache = arp_get_cache();
	for (ix = 0; ix < NUM_ARP_ENTRY; ix ++) {
		if (cache[ix].expire != 0)
			cons_printf(portid, "%2d %6d %15I %M\n",
			                    ix, cache[ix].expire / NET_TIMER_HZ,
			                    &cache[ix].ip_addr, cache[ix].mac_addr);
		}

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

/*
 * ifa_status -- ٥å֤ν
 */

static const char nd_state_str[][sizeof("INCOMPLETE")] = {
	"FREE",			/* ̤		*/
	"NO STATE",		/* ̤		*/
	"INCOMPLETE",		/* ̤		*/
	"REACHABLE",		/* ãǽ		*/
	"STALE",		/* ãǽ̤ǧ	*/
	"DELAY",		/* ãǽγǧԵ	*/
	"PROBE",		/* ãǽǧ	*/
	};

static void
ifa_status (ID portid, UB *line)
{
	const T_LLINFO_ND6	*cache;
	SYSTIM	now;
	int	ix;

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "ND Cache Status\n"
	            "IX Expire State      MAC Address       IP Address\n");

	/* expire ñ̤ [ms]*/
	syscall(get_tim(&now));
	cache = nd6_get_cache();
	for (ix = 0; ix < NUM_ND6_CACHE_ENTRY; ix ++) {
		if (cache[ix].state != ND6_LLINFO_FREE) {
			cons_printf(portid, "%2d %6d %10s %M %I\n",
			            ix, 
			            cache[ix].state == ND6_LLINFO_STALE ? 0 : (cache[ix].expire - now) / SYSTIM_HZ,
			            nd_state_str[cache[ix].state],
			            &cache[ix].ifaddr,
			            &cache[ix].addr);
			}
		}

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifdef SUPPORT_ETHER */

#if NET_COUNT_ENABLE

/*
 *  net_count_struct -- ͥåȥ׾
 */

static void
net_count_struct (ID portid, char *name, T_NET_COUNT *item)
{
	cons_printf(portid, "\n%s\n", name);
	cons_printf(portid, "\tƥåȿ\t%lu\n",	item->in_octets);
	cons_printf(portid, "\tƥåȿ\t%lu\n",	item->out_octets);
	cons_printf(portid, "\tХåȿ\t%lu\n",		item->in_packets);
	cons_printf(portid, "\tХåȿ\t%lu\n",		item->out_packets);
	cons_printf(portid, "\t顼Хåȿ\t%lu\n",	item->in_err_packets);
	cons_printf(portid, "\t顼Хåȿ\t%lu\n",	item->out_err_packets);
	}

/*
 *  net_count -- ͥåȥ׾
 */

static void
net_count (ID portid, UB *line)
{
	const T_NET_BUF_ENTRY	*tbl;
	SYSTIM	now;
	int	ix;

	WAI_NET_CONS_PRINTF();
	syscall(get_tim(&now));
	cons_printf(portid, "ͥåȥ׾\tв[ms]\t%lu\t", now);
	if (now > (1000 * 3600 * 24))
		cons_printf(portid, "%3lu %2lu %2luʬ %2lu\n",
		             now / (1000 * 3600 * 24),
		            (now / (1000 * 3600)) % 24,
		            (now / (1000 * 60  )) % 60,
		            (now /  1000        ) % 60);
	else
		cons_printf(portid, "%2lu %2luʬ %2lu\n",
		            (now / (1000 * 3600)) % 24,
		            (now / (1000 * 60  )) % 60,
		            (now /  1000        ) % 60);

#ifdef SUPPORT_PPP

	net_count_struct(portid, "HDLC", &net_count_hdlc);
	cons_printf(portid, "\nPPP\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",	net_count_ppp.in_octets);
	cons_printf(portid, "\tƥåȿ\t%lu\n",	net_count_ppp.out_octets);
	cons_printf(portid, "\tХåȿ\t%lu\n",		net_count_ppp.in_packets);
	cons_printf(portid, "\tХåȿ\t%lu\n",		net_count_ppp.out_packets);
	cons_printf(portid, "\t顼Хåȿ\t%lu\n",	net_count_ppp.in_err_packets);
	cons_printf(portid, "\t顼Хåȿ\t%lu\n",	net_count_ppp.out_err_packets);
	cons_printf(portid, "\tnet_buf ƼԿ\t%lu\n",	net_count_ppp_no_bufs);

	cons_printf(portid, "\nLCP\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",	net_count_ppp_lcp_in_octets);
	cons_printf(portid, "\tХåȿ\t%lu\n",		net_count_ppp_lcp_in_packets);

	cons_printf(portid, "\nIPCP\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",	net_count_ppp_ipcp_in_octets);
	cons_printf(portid, "\tХåȿ\t%lu\n",		net_count_ppp_ipcp_in_packets);

	cons_printf(portid, "\nPAP\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",	net_count_ppp_upap_in_octets);
	cons_printf(portid, "\tХåȿ\t%lu\n",		net_count_ppp_upap_in_packets);

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

	net_count_struct(portid, "ͥå", &net_count_ether);

	cons_printf(portid, "\nͥåȡͥåȥ󥿥ե\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_IN_OCTETS]);
	cons_printf(portid, "\tХåȿ\t%lu\n",				net_count_ether_nic[NC_ETHER_NIC_IN_PACKETS]);
	cons_printf(portid, "\t顼Хåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS]);
	cons_printf(portid, "\tnet_buf ƼԿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_NO_BUFS]);
	cons_printf(portid, "\tޥեֵѾ¥С\t%lu\n",	net_count_ether_nic[NC_ETHER_NIC_RXB_QOVRS]);
	cons_printf(portid, "\tƥåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_OUT_OCTETS]);
	cons_printf(portid, "\tХåȿ\t%lu\n",				net_count_ether_nic[NC_ETHER_NIC_OUT_PACKETS]);
	cons_printf(portid, "\t顼Хåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS]);
	cons_printf(portid, "\tꥸ\t%lu\n",				net_count_ether_nic[NC_ETHER_NIC_COLS]);
	cons_printf(portid, "\tޥեֵѾ¥С\t%lu\n",	net_count_ether_nic[NC_ETHER_NIC_TXB_QOVRS]);
	cons_printf(portid, "\tॢȿ	\t%lu\n",		net_count_ether_nic[NC_ETHER_NIC_TIMEOUTS]);
	cons_printf(portid, "\tꥻåȿ\t%lu\n",				net_count_ether_nic[NC_ETHER_NIC_RESETS]);

#endif	/* of #ifdef SUPPORT_ETHER */

#ifdef SUPPORT_INET4

#ifdef SUPPORT_ETHER

	net_count_struct(portid, "ARP", &net_count_arp);

#endif	/* of #ifdef SUPPORT_ETHER */

	cons_printf(portid, "\nIPv4\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",		net_count_ip4[NC_IP4_IN_OCTETS]);
	cons_printf(portid, "\tǡ\t%lu\n",		net_count_ip4[NC_IP4_IN_PACKETS]);
	cons_printf(portid, "\t顼ǡ\t%lu\n",	net_count_ip4[NC_IP4_IN_ERR_PACKETS]);
	cons_printf(portid, "\tå२顼\t%lu\n",		net_count_ip4[NC_IP4_IN_ERR_CKSUM]);
	cons_printf(portid, "\tĹ顼\t%lu\n",			net_count_ip4[NC_IP4_IN_ERR_SHORT]);
	cons_printf(portid, "\tС󥨥顼\t%lu\n",		net_count_ip4[NC_IP4_IN_ERR_VER]);
	cons_printf(portid, "\tɥ쥹顼\t%lu\n",		net_count_ip4[NC_IP4_IN_ERR_ADDR]);
	cons_printf(portid, "\tץȥ륨顼\t%lu\n",		net_count_ip4[NC_IP4_IN_ERR_PROTO]);
	cons_printf(portid, "\tץϿ\t%lu\n",		net_count_ip4[NC_IP4_OPTS]);
	cons_printf(portid, "\tʬ\t%lu\n",			net_count_ip4[NC_IP4_FRAG_IN]);
	cons_printf(portid, "\tʬե饰ȿ\t%lu\n",		net_count_ip4[NC_IP4_FRAG_IN_FRAGS]);
	cons_printf(portid, "\tʬƹ\t%lu\n",		net_count_ip4[NC_IP4_FRAG_IN_OK]);
	cons_printf(portid, "\tʬ˴\t%lu\n",			net_count_ip4[NC_IP4_FRAG_IN_DROP]);
	cons_printf(portid, "\tʬХåեƼԿ\t%lu\n",	net_count_ip4[NC_IP4_FRAG_IN_NO_BUF]);
	cons_printf(portid, "\tʬॢȿ\t%lu\n",		net_count_ip4[NC_IP4_FRAG_IN_TMOUT]);
	cons_printf(portid, "\tƥåȿ\t%lu\n",		net_count_ip4[NC_IP4_OUT_OCTETS]);
	cons_printf(portid, "\tǡ\t%lu\n",		net_count_ip4[NC_IP4_OUT_PACKETS]);
	cons_printf(portid, "\t顼ǡ\t%lu\n",	net_count_ip4[NC_IP4_OUT_ERR_PACKETS]);
	cons_printf(portid, "\tʬ\t%lu\n",			net_count_ip4[NC_IP4_FRAG_OUT]);
	cons_printf(portid, "\tʬե饰ȿ\t%lu\n",		net_count_ip4[NC_IP4_FRAG_OUT_FRAGS]);

	net_count_struct(portid, "ICMP", &net_count_icmp4);

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

	cons_printf(portid, "\nIPv6\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",		net_count_ip6[NC_IP6_IN_OCTETS]);
	cons_printf(portid, "\tǡ\t%lu\n",		net_count_ip6[NC_IP6_IN_PACKETS]);
	cons_printf(portid, "\t顼ǡ\t%lu\n",	net_count_ip6[NC_IP6_IN_ERR_PACKETS]);
	cons_printf(portid, "\tĹ顼\t%lu\n",			net_count_ip6[NC_IP6_IN_ERR_SHORT]);
	cons_printf(portid, "\tС󥨥顼\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_VER]);
	cons_printf(portid, "\tɥ쥹顼\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_ADDR]);
	cons_printf(portid, "\tץȥ륨顼\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_PROTO]);
	cons_printf(portid, "\tƥåȿ\t%lu\n",		net_count_ip6[NC_IP6_OUT_OCTETS]);
	cons_printf(portid, "\tǡ\t%lu\n",		net_count_ip6[NC_IP6_OUT_PACKETS]);
	cons_printf(portid, "\t顼ǡ\t%lu\n",	net_count_ip6[NC_IP6_OUT_ERR_PACKETS]);

	cons_printf(portid, "\nICMPv6\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_OCTETS]);
	cons_printf(portid, "\tѥåȿ\t%lu\n",			net_count_icmp6[NC_ICMP6_IN_PACKETS]);
	cons_printf(portid, "\t顼ѥåȿ\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_ERR_PACKETS]);
	cons_printf(portid, "\tå२顼\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_ERR_CKSUM]);
	cons_printf(portid, "\tƥåȿ\t%lu\n",		net_count_icmp6[NC_ICMP6_OUT_OCTETS]);
	cons_printf(portid, "\tѥåȿ\t%lu\n",			net_count_icmp6[NC_ICMP6_OUT_PACKETS]);
	cons_printf(portid, "\t顼ѥåȿ\t%lu\n",		net_count_icmp6[NC_ICMP6_OUT_ERR_PACKETS]);

	cons_printf(portid, "\nõ\n");
	cons_printf(portid, "\t롼μ\t%lu\n",		net_count_nd6[NC_ND6_RA_IN_PACKETS]);
	cons_printf(portid, "\t롼\t%lu\n",		net_count_nd6[NC_ND6_RS_OUT_PACKETS]);
	cons_printf(portid, "\tμ\t%lu\n",			net_count_nd6[NC_ND6_NA_IN_PACKETS]);
	cons_printf(portid, "\t\t%lu\n",			net_count_nd6[NC_ND6_NA_OUT_PACKETS]);
	cons_printf(portid, "\t\t%lu\n",			net_count_nd6[NC_ND6_NS_IN_PACKETS]);
	cons_printf(portid, "\t\t%lu\n",			net_count_nd6[NC_ND6_NS_OUT_PACKETS]);
	cons_printf(portid, "\tʣɥ쥹\t%lu\n",		net_count_nd6[NC_ND6_DAD_OUT_PACKETS]);

#endif	/* of #ifdef SUPPORT_INET6 */

#ifdef SUPPORT_TCP

	cons_printf(portid, "\nTCP\n");
	cons_printf(portid, "\tƥåȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_OCTETS]);
	cons_printf(portid, "\tǡƥåȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_DATA_OCTETS]);
	cons_printf(portid, "\tȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_SEGS]);
	cons_printf(portid, "\tǡȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_DATA_SEGS]);
	cons_printf(portid, "\t۵ޥȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_URG_SEGS]);
	cons_printf(portid, "\tإå\t%lu\n",		net_count_tcp[NC_TCP_RECV_BAD_HEADERS]);
	cons_printf(portid, "\tå\t%lu\n",	net_count_tcp[NC_TCP_RECV_BAD_CKSUMS]);
	cons_printf(portid, "\tACK \t%lu\n",			net_count_tcp[NC_TCP_RECV_ACKS]);
	cons_printf(portid, "\t¿ ACK \t%lu\n",		net_count_tcp[NC_TCP_RECV_DUP_ACKS]);
	cons_printf(portid, "\tRST \t%lu\n",			net_count_tcp[NC_TCP_RECV_RSTS]);
	cons_printf(portid, "\t¿ſ\t%lu\n",			net_count_tcp[NC_TCP_RECV_DUP_SEGS]);
	cons_printf(portid, "\t˴\t%lu\n",			net_count_tcp[NC_TCP_RECV_DROP_SEGS]);
	cons_printf(portid, "\t塼\t%lu\n",		net_count_tcp[NC_TCP_FREE_RCV_QUEUE]);
	cons_printf(portid, "\tǡƥåȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_DATA_OCTETS]);
	cons_printf(portid, "\t楻ȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_CNTL_SEGS]);
	cons_printf(portid, "\tȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_SEGS]);
	cons_printf(portid, "\tȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_REXMIT_SEGS]);
	cons_printf(portid, "\tǡȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_DATA_SEGS]);
	cons_printf(portid, "\t۵ޥȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_URG_SEGS]);
	cons_printf(portid, "\tACK \t%lu\n",			net_count_tcp[NC_TCP_SEND_ACKS]);
	cons_printf(portid, "\tRST \t%lu\n",			net_count_tcp[NC_TCP_SEND_RSTS]);
	cons_printf(portid, "\tRTT \t%lu\n",			net_count_tcp[NC_TCP_RTT_UPDATES]);
	cons_printf(portid, "\tưץ\t%lu\n",			net_count_tcp[NC_TCP_ACCEPTS]);
	cons_printf(portid, "\tǽưץ\t%lu\n",			net_count_tcp[NC_TCP_CONNECTS]);

#endif	/* of #ifdef SUPPORT_TCP */

#ifdef SUPPORT_UDP

	net_count_struct(portid, "UDP",  &net_count_udp);

#endif	/* of #ifdef SUPPORT_UDP */

	tbl = nbuf_get_tbl();
	cons_printf(portid, "\nͥåȥХåե\n\t\tѰտ\t׵\t\tƥ顼\n");
	for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
		cons_printf(portid, "\t%lu\t%lu\t%lu\t%lu\t%lu\n",
		                    tbl[ix].size,
		                    tbl[ix].prepares,
		                    tbl[ix].requests,
		                    tbl[ix].allocs,
		                    tbl[ix].errors);
		}

	cons_printf(portid, "\nͥåȥ׾\tв[ms]\t%lu\t", now);
	if (now > (1000 * 3600 * 24))
		cons_printf(portid, "%3lu %2lu %2luʬ %2lu\n",
		             now / (1000 * 3600 * 24),
		            (now / (1000 * 3600)) % 24,
		            (now / (1000 * 60  )) % 60,
		            (now /  1000        ) % 60);
	else
		cons_printf(portid, "%2lu %2luʬ %2lu\n",
		            (now / (1000 * 3600)) % 24,
		            (now / (1000 * 60  )) % 60,
		            (now /  1000        ) % 60);

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #if NET_COUNT_ENABLE */

#ifdef SUPPORT_INET4

#ifdef IP4_CFG_FRAGMENT

extern T_NET_BUF *frag_queue[];

/*
 *  nbuf_stat_ip4_frag_queue -- IPv4 ƹ塼ͥåȥХåե
 */

static void
nbuf_stat_ip4_frag_queue (ID portid)
{
	const T_NET_BUF_ENTRY	*tbl;
	T_NET_BUF	*nbuf;
	int		ix, fix, count;

	cons_printf(portid, "\nIPƹ塼\nIndex\tTime");
	tbl = nbuf_get_tbl();
	for (ix = nbuf_get_tbl_size(); ix -- > 0; )
		cons_printf(portid, "\t%d", tbl[ix].size);
	cons_printf(portid, "\n");

	for (fix = 0; fix < NUM_IP4_FRAG_QUEUE; fix ++) {
		if (frag_queue[fix] != NULL) {
			cons_printf(portid, "%d\t%d", fix, GET_QIP4_HDR(frag_queue[fix])->ttl);
			for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
				count = 0;
				for (nbuf = frag_queue[fix]; nbuf != NULL; nbuf = GET_QIP4_HDR(nbuf)->next)
					if (nbuf->idix == ix)
						count ++;
				cons_printf(portid, "\t%d", count);
				}
			cons_printf(portid, "\n");
			}
		}
	}

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

#endif	/* of #ifdef SUPPORT_INET4 */

/*
 *  nbuf_status -- ͥåȥХåե
 */

static void
nbuf_status (ID portid, UB *line)
{
	SYSTIM		now;

#if NET_COUNT_ENABLE
	const T_NET_BUF_ENTRY	*tbl;
	int		ix;
#endif	/* of #if NET_COUNT_ENABLE */

#ifdef SUPPORT_TCP
	T_NET_BUF	*nbuf;
	T_TCP_CCEP*	cep;
	T_TCP_Q_HDR*	tqhdr;
#endif

	WAI_NET_CONS_PRINTF();
	syscall(get_tim(&now));
	cons_printf(portid, "ͥåȥХåե\tв[ms]\t%lu\n", now);

#if NET_COUNT_ENABLE

	cons_printf(portid, "\nͥåȥХåե\n\t\tѰտ\t׵\t\tƥ顼\n");
	tbl = nbuf_get_tbl();
	for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
		cons_printf(portid, "\t%lu\t%lu\t%lu\t%lu\t%lu\n",
		                    tbl[ix].size,
		                    tbl[ix].prepares,
		                    tbl[ix].requests,
		                    tbl[ix].allocs,
		                    tbl[ix].errors);
		}

#endif	/* of #if NET_COUNT_ENABLE */

#ifdef SUPPORT_TCP

	cons_printf(portid, "\nCCEP\nCEPID\n");

	for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++) {
		cons_printf(portid, "%d", GET_TCP_CCEPID(cep));
		for (nbuf = cep->reassq; nbuf != NULL; nbuf = tqhdr->next) {
			tqhdr = GET_TCP_Q_HDR(nbuf, GET_TCP_IP_Q_HDR(nbuf)->thoff);
			cons_printf(portid, "[a:%08x.%d:%d-%d] ",
			            nbuf, nbuf->idix,
			            tqhdr->seq - cep->irs + tqhdr->soff,
			            tqhdr->seq - cep->irs + tqhdr->soff + tqhdr->slen);
			}

#ifdef TCP_CFG_RWBUF_CSAVE
		for (nbuf = cep->rwbufq; nbuf != NULL; nbuf = tqhdr->next) {
			tqhdr = GET_TCP_Q_HDR(nbuf, GET_TCP_IP_Q_HDR(nbuf)->thoff);
			cons_printf(portid, "[r:%08x.%d] ",
			            nbuf, nbuf->idix,
			            tqhdr->seq - cep->irs + tqhdr->soff,
			            tqhdr->seq - cep->irs + tqhdr->soff + tqhdr->slen);
			}
#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE */

#ifdef TCP_CFG_SWBUF_CSAVE
		if (cep->swbufq != NULL)
			cons_printf(portid, "[s:%08x.%d] ", cep->swbufq, cep->swbufq->idix);
#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

		cons_printf(portid, "\n");
		}

#endif	/* of #ifdef SUPPORT_TCP */

#ifdef SUPPORT_INET4

#ifdef IP4_CFG_FRAGMENT

	nbuf_stat_ip4_frag_queue(portid);

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

#endif	/* of #ifdef SUPPORT_INET4 */

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#ifdef SUPPORT_INET4

#if NUM_ROUTE_ENTRY > 0

/*
 *  routing_table_status -- ϩɽν
 */

static void
routing_table_status (ID portid, UB *line)
{
	int	ix;

	if ('0' <= *(line = skip_blanks(line)) && *line <= '9') {
		T_IN4_ADDR	target, mask, gateway;

		ix = atoi(line);
		while ('0' <= *line && *line <= '9')
			line ++;
		line = GET_IPADDR(&target,  skip_blanks(line));
		line = GET_IPADDR(&mask,    skip_blanks(line));
		       GET_IPADDR(&gateway, skip_blanks(line));
		in4_add_route(ix, target, mask, gateway);
		}

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "Routing Table Status\n"
	            "IX Target          Mask            Gateway         Expire\n");

	for (ix = 0; ix < NUM_ROUTE_ENTRY; ix ++) {
		if ((routing_tbl[ix].flags & IN_RTF_DEFINED) == 0)
			;
		else if ((routing_tbl[ix].flags & IN_RTF_REDIRECT) != 0)
			cons_printf(portid, "%2d %15I %15I %15I %4d\n",
			            ix,
			            &routing_tbl[ix].target,
			            &routing_tbl[ix].mask,
			            &routing_tbl[ix].gateway,
			            &routing_tbl[ix].expire);
		else
			cons_printf(portid, "%2d %15I %15I %I\n",
			            ix,
			            &routing_tbl[ix].target,
			            &routing_tbl[ix].mask,
			            &routing_tbl[ix].gateway);
		            
		}

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

#if NUM_ND6_DEF_RTR_ENTRY > 0

/*
 *  defrtrlist_status -- ǥեȥ롼ꥹȾ֤ν
 */

static void
defrtrlist_status (ID portid, UB *line)
{
	const T_DEF_ROUTER	*dr;
	SYSTIM	now;
	int	ix;

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "Default Router List Status\n"
	            "IX Expire Lifetime flags IP Address\n");

	/* expire ñ̤ [ms]*/
	syscall(get_tim(&now));
	dr = nd6_get_drl();
	for (ix = 0; ix < NUM_ND6_DEF_RTR_ENTRY; ix ++) {
		if (dr[ix].state != ND6_DEF_RTR_FREE) {
			cons_printf(portid, "%2d %6d %8d    %02x %I\n",
			            ix, 
			            (W)(dr[ix].expire - now) <= 0 ? 0 : (dr[ix].expire - now) / SYSTIM_HZ,
			             dr[ix].lifetime / SYSTIM_HZ,
			             dr[ix].flags,
			            &dr[ix].addr);
			}
		}

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #if NUM_ND6_DEF_RTR_ENTRY > 0 */

#if NUM_ROUTE_ENTRY > 0

/*
 *  routing_table_status -- ϩɽν
 */

static void
routing_table_status (ID portid, UB *line)
{
	SYSTIM	now;
	int	ix;

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "Routing Table Status\n"
	            "IX Expire flags Prefix Target                         Gateway\n");

	for (ix = 0; ix < NUM_STATIC_ROUTE_ENTRY; ix ++) {
		cons_printf(portid, "%2d STATIC     - %6d %30I %I\n",
		            ix,
		             routing_tbl[ix].prefix_len,
		            &routing_tbl[ix].target,
		            &routing_tbl[ix].gateway);
		            
		}

	/* expire ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	for ( ; ix < NUM_ROUTE_ENTRY; ix ++)
		if (routing_tbl[ix].flags & IN_RTF_DEFINED)
			cons_printf(portid, "%2d %6d    %02x %6d %30I %I\n",
			            ix,
			            (W)(routing_tbl[ix].expire - now) <= 0 ? 0 : routing_tbl[ix].expire - now,
			             routing_tbl[ix].flags,
			             routing_tbl[ix].prefix_len,
			            &routing_tbl[ix].target,
			            &routing_tbl[ix].gateway);

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

#endif	/* of #ifdef SUPPORT_INET6 */

#if NUM_ROUTE_ENTRY > 0

/*
 *  routing_status -- 롼ƥ󥰾
 */

static void
routing_status (ID portid, UB *line)
{
	switch (*line) {

#ifdef SUPPORT_INET6

#if NUM_ND6_DEF_RTR_ENTRY > 0

	case 'l':		/* ǥեȥ롼ꥹȾ */
		defrtrlist_status(portid, line + 1);
		break;

#endif	/* of #if NUM_ND6_DEF_RTR_ENTRY > 0 */

#endif	/* of #ifdef SUPPORT_INET6 */

	default:		/* 롼ƥɽ */
		routing_table_status(portid, line);
		break;

		break;
		}
	}

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

/*
 *  network_status -- ͥåȥξ֤ν
 */

static void
network_status (ID portid, UB *line)
{
	switch (*line) {

#ifdef SUPPORT_TCP

	case 't':		/* TCP status */
		tcp_status(portid, line + 1);
		break;

#endif	 /* of #ifdef SUPPORT_TCP */

	case 'b':		/* ͥåȥХåե */
		nbuf_status(portid, line + 1);
		break;

#if NET_COUNT_ENABLE

	case 'c':		/* ͥåȥ׾ */
		net_count(portid, line + 1);
		break;

#endif	/* of #if NET_COUNT_ENABLE */

#ifdef SUPPORT_ETHER

	case 'a':		/* IF ɥ쥹 */
		ifa_status(portid, line + 1);
		break;

#endif	/* of #ifdef SUPPORT_ETHER */

#if NUM_ROUTE_ENTRY > 0

	case 'r':		/* 롼ƥ󥰾 */
		routing_status(portid, line + 1);
		break;

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

	default:
		cons_printf(portid, "no such command: '%c%c'\n", *(line - 1), *line);
		SIG_NET_CONS_PRINTF();
		FLUSH_SND_BUFF();
		break;
		}
	}

#ifdef SUPPORT_INET4

/*
 *  ifconfig -- ͥåȥ󥿥եι
 */

static void
ifconfig (ID portid, UB *line)
{
	T_IFNET		*ifp = IF_GET_IFNET();
	T_IN4_ADDR	bc;

#ifdef SUPPORT_ETHER

	if (*(line = skip_blanks(line))) {
		T_IN4_ADDR	addr, mask;

		GET_IPADDR(&mask, skip_blanks(GET_IPADDR(&addr, line)));
		in4_add_ifaddr(addr, mask);
		}

#endif	/* of #ifdef SUPPORT_ETHER */

	WAI_NET_CONS_PRINTF();
	cons_printf(portid,
	            "Network Interface Configurations\n");

#ifdef SUPPORT_ETHER

	cons_printf(portid,
	            "ether: %M\n",
	            IF_ETHER_NIC_GET_SOFTC()->ifaddr.lladdr);

#endif	/* of #ifdef SUPPORT_ETHER */

	bc = (ifp->in_ifaddr.addr & ifp->in_ifaddr.mask) | ~ifp->in_ifaddr.mask;
	cons_printf(portid,
	            "inet:  %I, mask: %I, boadcast: %I\n",
	            &ifp->in_ifaddr.addr,
	            &ifp->in_ifaddr.mask,
	            &bc);

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

/*
 *  ifconfig -- ͥåȥ󥿥եι
 */

static void
ifconfig (ID portid, UB *line)
{
#ifdef SUPPORT_ETHER

	T_IF_SOFTC	*ic;
	T_IFNET		*ifp = IF_GET_IFNET();
	int		ix;
	SYSTIM		now;

	WAI_NET_CONS_PRINTF();
	ic = IF_ETHER_NIC_GET_SOFTC();
	cons_printf(portid, "ether: %M\ninet6:\nIX   Expire Lifetime RTR Flags IP Address\n",
	                    ic->ifaddr.lladdr);

	/* expire  vltime ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	for (ix = 0; ix < MAX_IN6_IFADDR_CNT; ix ++) {
		if (ifp->in_ifaddrs[ix].flags & IN6_IFF_DEFINED) {
			cons_printf(portid, " %d", ix);
			if (ifp->in_ifaddrs[ix].lifetime.vltime == ND6_INFINITE_LIFETIME)
				cons_printf(portid, "    INFIN    INFIN");
			else
				cons_printf(portid, " %8d %8d",
				                    (ifp->in_ifaddrs[ix].lifetime.expire - now),
				                    ifp->in_ifaddrs[ix].lifetime.vltime);

			if (ifp->in_ifaddrs[ix].flags & IN6_IFF_AUTOCONF) {
				if (ifp->in_ifaddrs[ix].rtr_index == IN6_RTR_IX_UNREACH)
					cons_printf(portid, "   *");
				else
					cons_printf(portid, "  %2d", ifp->in_ifaddrs[ix].rtr_index);
				}
			else
				cons_printf(portid, "   -");

			cons_printf(portid, "    %02x %I\n",
			                    ifp->in_ifaddrs[ix].flags,
			                    &ifp->in_ifaddrs[ix].addr);
			}
		}

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();

#endif	/* of #ifdef SUPPORT_ETHER */
	}

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  show_config -- ե졼ɽ
 */

static void
show_config (ID portid, UB *line)
{
#if defined(SUPPORT_INET4)
	T_IN4_ADDR	addr;
#endif

#if defined(DHCP_CFG)

	cons_printf(portid, "DHCP:\n");

	cons_printf(portid, "  DHCP_CFG: On\n");

#endif	/* of #if define(DHCP_CFG) */

#if defined(SUPPORT_TCP)

	cons_printf(portid, "TCP:\n");

	cons_printf(portid, "  TCP_CFG_PASSIVE_OPEN: ");
#if defined(TCP_CFG_PASSIVE_OPEN)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  TCP_CFG_OPT_MSS:      ");
#if defined(TCP_CFG_OPT_MSS)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  TCP_CFG_DELAY_ACK:    ");
#if defined(TCP_CFG_DELAY_ACK)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  TCP_CFG_ALWAYS_KEEP:  ");
#if defined(TCP_CFG_ALWAYS_KEEP)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  TCP_CFG_RWBUF_CSAVE:  ");
#if defined(TCP_CFG_RWBUF_CSAVE_ONLY)
	cons_printf(portid, "Only, TCP_CFG_RWBUF_CSAVE_MAX_QUEUES: %2d\n",
	                    TCP_CFG_RWBUF_CSAVE_MAX_QUEUES);
#elif defined(TCP_CFG_RWBUF_CSAVE)
	cons_printf(portid, "On,   TCP_CFG_RWBUF_CSAVE_MAX_QUEUES: %2d\n",
	                    TCP_CFG_RWBUF_CSAVE_MAX_QUEUES);
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  TCP_CFG_SWBUF_CSAVE:  ");
#if defined(TCP_CFG_SWBUF_CSAVE_ONLY)
	cons_printf(portid, "Only, TCP_CFG_SWBUF_CSAVE_MAX_SIZE: %4d\n"
	                    "                        "
	                    "      TCP_CFG_SWBUF_CSAVE_MIN_SIZE: %4d\n",
	                    TCP_CFG_SWBUF_CSAVE_MAX_SIZE, 
                            TCP_CFG_SWBUF_CSAVE_MIN_SIZE);
#elif defined(TCP_CFG_SWBUF_CSAVE)
	cons_printf(portid, "On,   TCP_CFG_SWBUF_CSAVE_MAX_SIZE: %4d\n"
	                    "                        "
	                    "      TCP_CFG_SWBUF_CSAVE_MIN_SIZE: %4d\n",
	                    TCP_CFG_SWBUF_CSAVE_MAX_SIZE, 
                            TCP_CFG_SWBUF_CSAVE_MIN_SIZE);
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  TCP_CFG_NON_BLOCKING: ");
#if defined(TCP_CFG_NON_BLOCKING)
#if defined(USE_TCP_NON_BLOCKING)
	cons_printf(portid, "Use\n");
#else
	cons_printf(portid, "On\n");
#endif
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  USE_COPYSAVE_API:     ");
#if defined(USE_COPYSAVE_API)
	cons_printf(portid, "Use\n");
#else
	cons_printf(portid, "Off\n");
#endif

#if NUM_TCP_TW_CEP_ENTRY > 0
	cons_printf(portid, "  TCP_TW_CEP:           On, NUM_TCP_TW_CEP_ENTRY:     %d\n", NUM_TCP_TW_CEP_ENTRY);
#else
	cons_printf(portid, "  TCP_TW_CEP:           Off\n");
#endif

#if defined(TCP_CFG_TRACE)
	cons_printf(portid, "  TCP_CFG_TRACE:        On, TCP_CFG_TRACE_LPORTNO:    %d\n", TCP_CFG_TRACE_LPORTNO);
#if defined(SUPPORT_INET4)
	addr = TCP_CFG_TRACE_IPV4_RADDR;
	cons_printf(portid, "                            TCP_CFG_TRACE_IPV4_RADDR: %I\n", &addr);
#endif
	cons_printf(portid, "                            TCP_CFG_TRACE_RPORTNO:    %d\n", TCP_CFG_TRACE_RPORTNO);
#else
	cons_printf(portid, "  TCP_CFG_TRACE:        Off\n");
#endif

	cons_printf(portid, "  MAX_TCP_SND_SEG:      %4d\n", MAX_TCP_SND_SEG);
	cons_printf(portid, "  DEF_TCP_SND_SEG:      %4d\n", DEF_TCP_SND_SEG);
	cons_printf(portid, "  MAX_TCP_RCV_SEG:      %4d\n", MAX_TCP_RCV_SEG);
	cons_printf(portid, "  DEF_TCP_RCV_SEG:      %4d\n", DEF_TCP_RCV_SEG);
	cons_printf(portid, "  MAX_TCP_REALLOC_SIZE: %4d\n", MAX_TCP_REALLOC_SIZE);

#endif	/* of #if defined(SUPPORT_TCP) */

#if defined(SUPPORT_UDP)

	cons_printf(portid, "UDP:\n");

	cons_printf(portid, "  UDP_CFG_IN_CHECKSUM:  ");
#if defined(UDP_CFG_IN_CHECKSUM)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  UDP_CFG_OUT_CHECKSUM: ");
#if defined(UDP_CFG_OUT_CHECKSUM)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  UDP_CFG_NON_BLOCKING: ");
#if defined(UDP_CFG_NON_BLOCKING)
#if defined(USE_UDP_NON_BLOCKING)
	cons_printf(portid, "Use\n");
#else
	cons_printf(portid, "On\n");
#endif
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  NUM_DTQ_UDP_RCVQ:    %d\n", NUM_DTQ_UDP_RCVQ);
	cons_printf(portid, "  NUM_DTQ_UDP_CB_RCVQ: %d\n", NUM_DTQ_UDP_CB_RCVQ);
	cons_printf(portid, "  NUM_DTQ_UDP_OUTPUT:  %d\n", NUM_DTQ_UDP_OUTPUT);

#endif	/* of #if defined(SUPPORT_UDP) */

	cons_printf(portid, "ICMP:\n");

	cons_printf(portid, "  ICMP_CFG_CALLBACK_ECHO_REPLY: ");
#if defined(ICMP_CFG_CALLBACK_ECHO_REPLY)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  ICMP_REPLY_ERROR:             ");
#if defined(ICMP_REPLY_ERROR)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

#if NUM_REDIRECT_ROUTE_ENTRY > 0
	cons_printf(portid, "  TMO_IN_REDIRECT: %4d[s]\n", TMO_IN_REDIRECT / NET_TIMER_HZ);
#endif

#if defined(SUPPORT_INET4)

	cons_printf(portid, "IPv4:\n");

	cons_printf(portid, "  IP4_CFG_FRAGMENT: ");

#if defined(IP4_CFG_FRAGMENT)
	cons_printf(portid, "On\n");
	cons_printf(portid, "    NUM_IP4_FRAG_QUEUE:       %4d\n", NUM_IP4_FRAG_QUEUE);
	cons_printf(portid, "    IP4_CFG_FRAG_REASSM_SIZE: %4d\n", IP4_CFG_FRAG_REASSM_SIZE);
#else
	cons_printf(portid, "Off\n");
#endif	/* of #if defined(IP4_CFG_FRAGMENT) */

#if defined(SUPPORT_ETHER)
	addr = IPV4_ADDR_LOCAL;
	cons_printf(portid, "  IPV4_ADDR_LOCAL:      %I\n", &addr);
	addr = IPV4_ADDR_LOCAL_MASK;
	cons_printf(portid, "  IPV4_ADDR_LOCAL_MASK: %I\n", &addr);
	addr = IPV4_ADDR_DEFAULT_GW;
	cons_printf(portid, "  IPV4_ADDR_DEFAULT_GW: %I\n", &addr);
#endif	/* of #if defined(SUPPORT_ETHER) */

	cons_printf(portid, "  Routing Table:\n");
	cons_printf(portid, "    NUM_STATIC_ROUTE_ENTRY:   %d\n", NUM_STATIC_ROUTE_ENTRY);
	cons_printf(portid, "    NUM_REDIRECT_ROUTE_ENTRY: %d\n", NUM_REDIRECT_ROUTE_ENTRY);

#endif	/* of #if defined(SUPPORT_INET4) */

#if defined(SUPPORT_INET6)

	cons_printf(portid, "IPv6:\n");

	cons_printf(portid, "  Routing Table:\n");
	cons_printf(portid, "    NUM_STATIC_ROUTE_ENTRY:   %d\n", NUM_STATIC_ROUTE_ENTRY);
	cons_printf(portid, "    NUM_REDIRECT_ROUTE_ENTRY: %d\n", NUM_REDIRECT_ROUTE_ENTRY);

	cons_printf(portid, "ND:\n");
	cons_printf(portid, "  TMO_ND6_RTR_SOL_DELAY:    %5d[ms]\n", TMO_ND6_RTR_SOL_DELAY);
	cons_printf(portid, "  TMO_ND6_RTR_SOL_INTERVAL: %5d[ms]\n", TMO_ND6_RTR_SOL_INTERVAL);
	cons_printf(portid, "  NUM_IP6_DAD_COUNT:        %5d\n",     NUM_IP6_DAD_COUNT);
	cons_printf(portid, "  NUM_ND6_CACHE_ENTRY:      %5d\n",     NUM_ND6_CACHE_ENTRY);

#if defined(SUPPORT_ETHER)

	cons_printf(portid, "  NUM_ND6_DEF_RTR_ENTRY     %5d\n",     NUM_ND6_DEF_RTR_ENTRY);
	cons_printf(portid, "  NUM_ND6_RTR_SOL_RETRY     %5d\n",     NUM_ND6_RTR_SOL_RETRY);

	cons_printf(portid, "  IP6_CFG_AUTO_LINKLOCAL: ");
#if defined(IP6_CFG_AUTO_LINKLOCAL)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

#endif	/* of #if defined(SUPPORT_ETHER) */

#endif	/* of #if defined(SUPPORT_INET6) */

#if defined(SUPPORT_INET4) && defined(SUPPORT_ETHER)

	cons_printf(portid, "ARP:\n");
	cons_printf(portid, "  ARP_CACHE_KEEP: %4d[s]\n", ARP_CACHE_KEEP / NET_TIMER_HZ);

#endif	/* of #if defined(SUPPORT_INET4) && defined(SUPPORT_ETHER) */

#if defined(SUPPORT_ETHER)

	cons_printf(portid, "Ethernet:\n");

	cons_printf(portid, "  NUM_DTQ_ETHER_OUTPUT: %d\n", NUM_DTQ_ETHER_OUTPUT);

	cons_printf(portid, "  ETHER_CFG_ACCEPT_ALL:    ");
#if defined(ETHER_CFG_ACCEPT_ALL)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  ETHER_CFG_UNEXP_WARNING: ");
#if defined(ETHER_CFG_UNEXP_WARNING)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  ETHER_CFG_802_WARNING:   ");
#if defined(ETHER_CFG_802_WARNING)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	cons_printf(portid, "  ETHER_CFG_MCAST_WARNING: ");
#if defined(ETHER_CFG_MCAST_WARNING)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

#endif	/* of #if defined(SUPPORT_ETHER) */

#if defined(SUPPORT_PPP)

	cons_printf(portid, "PPP:\n");

	cons_printf(portid, "  HDLC_PORTNO: %d", HDLC_PORTID);

	cons_printf(portid, "  PPP_IDLE_TIMEOUT: ");
#if defined(PPP_IDLE_TIMEOUT)
	cons_printf(portid, "  %4d[s]\n" PPP_IDLE_TIMEOUT / NET_TIMER_HZ);
#else
	cons_printf(portid, "  Off\n");
#endif

	cons_printf(portid, "  PPP_CFG_MODEM: ");
#if defined(PPP_CFG_MODEM)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

#endif	/* of #if defined(SUPPORT_PPP) */

	cons_printf(portid, "Network Buffer:\n");

#if defined(NUM_MPF_NET_BUF_64)
	cons_printf(portid, "  NUM_MPF_NET_BUF_64:        %2d\n", NUM_MPF_NET_BUF_64);
#endif

#if defined(NUM_MPF_NET_BUF_CSEG)
	cons_printf(portid, "  NUM_MPF_NET_BUF_CSEG:      %2d\n", NUM_MPF_NET_BUF_CSEG);
#endif

#if defined(NUM_MPF_NET_BUF_128)
	cons_printf(portid, "  NUM_MPF_NET_BUF_128:       %2d\n", NUM_MPF_NET_BUF_128);
#endif

#if defined(NUM_MPF_NET_BUF_256)
	cons_printf(portid, "  NUM_MPF_NET_BUF_256:       %2d\n", NUM_MPF_NET_BUF_256);
#endif

#if defined(NUM_MPF_NET_BUF_512)
	cons_printf(portid, "  NUM_MPF_NET_BUF_512:       %2d\n", NUM_MPF_NET_BUF_512);
#endif

#if defined(NUM_MPF_NET_BUF_IP_MSS)
	cons_printf(portid, "  NUM_MPF_NET_BUF_IP_MSS:    %2d\n", NUM_MPF_NET_BUF_IP_MSS);
#endif

#if defined(NUM_MPF_NET_BUF_1024)
	cons_printf(portid, "  NUM_MPF_NET_BUF_1024:      %2d\n", NUM_MPF_NET_BUF_1024);
#endif

#if defined(NUM_MPF_NET_BUF_IPV6_MMTU)
	cons_printf(portid, "  NUM_MPF_NET_BUF_IPV6_MMTU: %2d\n", NUM_MPF_NET_BUF_IPV6_MMTU);
#endif

#if defined(NUM_MPF_NET_BUF_IF_PDU)
	cons_printf(portid, "  NUM_MPF_NET_BUF_IF_PDU:    %2d\n", NUM_MPF_NET_BUF_IF_PDU);
#endif

#if defined(NUM_MPF_NET_BUF_REASSM)
	cons_printf(portid, "  NUM_MPF_NET_BUF_REASSM:    %2d\n", NUM_MPF_NET_BUF_REASSM);
#endif

	cons_printf(portid, "Network Counter Mask: %08x\n", NET_COUNT_ENABLE);

	cons_printf(portid, "SUPPORT_MIB: ");
#if defined(SUPPORT_MIB)
	cons_printf(portid, "On\n");
#else
	cons_printf(portid, "Off\n");
#endif

	SIG_NET_CONS_PRINTF();
	FLUSH_SND_BUFF();
	}

/*
 *  ǥХåޥɲ
 */

static void
dbg_parse (ID portid, UB *line)
{
	int	cepid;
	ER	error;

	switch (*line) {

	case 'i':

		if (*(line + 1) == 'f')
			ifconfig(portid, line + 2);

#ifdef SUPPORT_PPP

#ifdef PPP_CFG_MODEM

		else if (lcp_fsm.state == PPP_FSM_STOPPED)
			dial();		/* initiate */

#else	/* of #ifdef PPP_CFG_MODEM */

		else if (lcp_fsm.state == PPP_FSM_STOPPED)
			lcp_open(PPP_OPEN_ACTIVE);

#endif	/* of #ifdef PPP_CFG_MODEM */

#endif	/* of #ifdef SUPPORT_PPP */

		break;

#ifdef SUPPORT_PPP

	case 'd':		/* disconnect */
		if (lcp_fsm.state != PPP_FSM_STOPPED)
			lcp_close();
		break;

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

#ifdef USE_NET_CONS

	case 'd':		/* disconnect */
		discon_net_cons();
		break;

#endif	/* of #ifdef USE_NET_CONS */

#endif	/* of #ifdef SUPPORT_ETHER */

	case 'p':		/* ping or task status */

		if (*(line + 1) == 's')
			task_status(portid, skip_blanks(line + 2));

#ifdef USE_PING

		else {
			int		tmo;
			T_IN_ADDR	addr;

			tmo = atoi(skip_blanks(GET_IPADDR(&addr, skip_blanks(line + 1))));
			if (tmo <= 0)
				tmo = 10;
			PING(&addr, (UINT)tmo, 64);
			}

#endif	/* of #ifdef USE_PING */

		break;

	case 'n':		/* network status */
		network_status(portid, line + 1);
		break;

#if defined(USE_UDP_ECHO_CLI) || defined(USE_TCP_ECHO_CLI)

	case 'e':	/* echo client */
		switch (*(line + 1)) {

#ifdef USE_UDP_ECHO_CLI

		case 'u':	/* UDP echo client */
			line += 2;
			if ((error = psnd_dtq(DTQ_UDP_ECHO_CLI, (VP_INT)line)) != E_OK) {
				cons_printf(portid, "[UDP ECHO CON] error: %s\n",
				       itron_strerror(error));
				SIG_NET_CONS_PRINTF();
				FLUSH_SND_BUFF();
				}
			break;

#endif	/* of #ifdef USE_UDP_ECHO_CLI */

#ifdef USE_TCP_ECHO_CLI

		case 't':	/* TCP echo client */
			line += 2;
			if ((error = psnd_dtq(DTQ_TCP_ECHO_CLI, (VP_INT)line)) != E_OK) {
				cons_printf(portid, "[TCP ECHO CON] error: %s\n",
				       itron_strerror(error));
				SIG_NET_CONS_PRINTF();
				FLUSH_SND_BUFF();
				}
			break;

		case 's':	/* cancel TCP echo */
			tcp_echo_cli_valid = FALSE;
			break;

#endif	/* of #ifdef USE_TCP_ECHO_CLI */

			}

		break;

#endif	/* of #if defined(USE_UDP_ECHO_CLI) || defined(USE_TCP_ECHO_CLI) */

#if defined(USE_UDP_DISCARD_CLI) || defined(USE_TCP_DISCARD_CLI)

	case 'b':	/* discard client */
		switch (*(line + 1)) {

#ifdef USE_UDP_DISCARD_CLI

		case 'u':	/* UDP discard client */
			line += 2;
			if ((error = psnd_dtq(DTQ_UDP_DISCARD_CLI, (VP_INT)line)) != E_OK) {
				cons_printf(portid, "[UDP DISCARD CON] error: %s\n",
				       itron_strerror(error));
				SIG_NET_CONS_PRINTF();
				FLUSH_SND_BUFF();
				}
			break;

#endif	/* of #ifdef USE_UDP_DISCARD_CLI */

#ifdef USE_TCP_DISCARD_CLI

		case 't':	/* TCP discard client */
			line += 2;
			if ((error = psnd_dtq(DTQ_TCP_DISCARD_CLI, (VP_INT)line)) != E_OK) {
				cons_printf(portid, "[TCP DISCARD CON] error: %s\n",
				       itron_strerror(error));
				SIG_NET_CONS_PRINTF();
				FLUSH_SND_BUFF();
				}

			break;

		case 's':	/* cancel TCP discard client */
			tcp_discard_cli_valid = FALSE;
			break;

#endif	/* of #ifdef USE_TCP_DISCARD_CLI */

			}

		break;

#endif	/* of #if defined(USE_UDP_DISCARD_CLI) || defined(USE_TCP_DISCARD_CLI) */

	case 'c':		/* cancel CEP */
		switch (*(line + 1)) {

#ifdef SUPPORT_UDP

		case 'u':	/* cancel UDP */
			cepid = atoi(line = skip_blanks(line + 2));
			while ('0' <= *line && *line <= '9')
				line ++;
			if ((error = udp_can_cep((ID)cepid, atoi(skip_blanks(line)))) != E_OK) {
				cons_printf(portid, "[UDP CAN CEP] error: %s\n",
				       itron_strerror(error));
				SIG_NET_CONS_PRINTF();
				FLUSH_SND_BUFF();
				}
			break;

#endif	/* of #ifdef SUPPORT_UDP */

#ifdef SUPPORT_TCP

		case 't':	/* cancel TCP */
			cepid = atoi(line = skip_blanks(line + 2));
			while ('0' <= *line && *line <= '9')
				line ++;
			if ((error = tcp_can_cep((ID)cepid, atoi(skip_blanks(line)))) != E_OK) {
				cons_printf(portid, "[TCP CAN CEP] error: %s\n",
				       itron_strerror(error));
				SIG_NET_CONS_PRINTF();
				FLUSH_SND_BUFF();
				}
			break;

#endif	/* of #ifdef SUPPORT_TCP */

		case 'f':	/* show configurations */
			show_config(portid, line + 1);
			break;
			}

		break;

	case 'r':		/* release wait task */
		syscall(rel_wai(atoi(skip_blanks(line + 1))));
		break;
	case 'w':		/* wake up task */
		syscall(wup_tsk(atoi(skip_blanks(line + 1))));
		break;

	default:

		if (*line) {

#ifdef USE_EXTRA_PARSE

			extra_parse(line);

#else	/* of #ifdef USE_EXTRA_PARSE */

			cons_printf(portid, "no such command: '%c'\n", *line);
			SIG_NET_CONS_PRINTF();
			FLUSH_SND_BUFF();

#endif	/* of #ifdef USE_EXTRA_PARSE */

			}
		break;
		}
	}

/*
 *  ǥХå󥽡륿
 */

void
dbg_con_task (VP_INT exinf)
{
	static UB line[DBG_LINE_SIZE + 1];

	UINT	len;
	ID	tskid;

	get_tid(&tskid);
	//vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG));
	cons_printf(CONSOLE_PORTID, "[CONSOLE:%d] started.\n", tskid);
	syscall(serial_ctl_por(CONSOLE_PORTID,
	                       IOCTL_ECHO  | IOCTL_CRLF  |
	                       IOCTL_FCSND | IOCTL_FCANY | IOCTL_FCRCV));
	while (TRUE) {
		len = cons_getline(CONSOLE_PORTID, line, DBG_LINE_SIZE);
		dbg_parse(CONSOLE_PORTID, line);
		}
	}

#endif	/* of #ifdef USE_DBG_CONS */
