/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_subr_ncs.c,v 1.3 2006/02/07 10:10:51 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_subr.c	8.2 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_subr.c,v 1.49.2.4 1999/08/29 16:29:55 peter Exp $
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet6/in6.h>
#include <netinet6/in6_var.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet6/nd6.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>
#include <netinet/in_itron.h>

#ifdef SUPPORT_TCP

#ifndef TCP_CFG_SWBUF_CSAVE_ONLY

/*
 *  TCP ̿üɥХåեξʥԡǽ̵
 */

/*
 *  tcp_read_swbuf -- ɥХåեǡɤ߽Ф
 */

void
tcp_read_swbuf_ncs (T_TCP_CCEP *cep, T_NET_BUF *output, UINT len, UINT doff)
{
	UB	*wptr, *rptr;

	/* SDU 礭å롣*/
	if (GET_IP_SDU_SIZE(GET_IP_HDR(output)) < GET_TCP_HDR_SIZE2(output, IF_IP_TCP_HDR_OFFSET) + len) {
		syslog(LOG_INFO, "[TCP] shrink SUD len: %d -> %d",
		       (UH)len, (UH)(GET_IP_SDU_SIZE(GET_IP_HDR(output)) - GET_TCP_HDR_SIZE2(output, IF_IP_TCP_HDR_OFFSET)));
		len = GET_IP_SDU_SIZE(GET_IP_HDR(output)) - GET_TCP_HDR_SIZE2(output, IF_IP_TCP_HDR_OFFSET);
		}

	wptr = GET_TCP_SDU(output, IF_IP_TCP_HDR_OFFSET);

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	rptr = cep->sbuf_rptr + doff;
	if (rptr - (UB*)cep->sbuf > cep->sbufsz) {

		/* žϤɥХåեνĶȤν*/
		rptr = (UB*)cep->sbuf_rptr - (cep->sbufsz - doff);
		}
	else if (len + (rptr - (UB*)cep->sbuf) > cep->sbufsz) {
		UINT sub;

		/* žϰϤ饦ɤȤν */
		sub = (UINT)(cep->sbufsz - (rptr - (UB*)cep->sbuf));
		memcpy((VP)wptr, rptr, (size_t)sub);
		len  -= sub;
		wptr += sub;
		rptr  = (UB*)cep->sbuf;
		}
	memcpy((VP)wptr, rptr, (size_t)len);

	NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_DATA_SEGS],   1);
	NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_DATA_OCTETS], len);

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));
	}

/*
 *  tcp_drop_swbuf -- ɥХåեꤵ줿ƥåʬ롣
 */

void
tcp_drop_swbuf_ncs (T_TCP_CCEP *cep, UINT len)
{
	UINT	last;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	last = cep->swbuf_count;

	if (cep->sbuf_rptr + len > (UB*)cep->sbuf + cep->sbufsz)
		/* 饦ɤȤη׻ */
		cep->sbuf_rptr -= cep->sbufsz - len;
	else
		cep->sbuf_rptr += len;
	cep->swbuf_count -= (UH)len;

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

#ifdef TCP_CFG_NON_BLOCKING

	if (cep->snd_nblk_tfn == TFN_TCP_GET_BUF) {	/* Υ֥å󥰥 */

		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		/* ǡĹ׻롣*/
		if (cep->sbufsz - cep->swbuf_count > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf))
			/* ߥݥ󥿤饦ɤȤϡߥݥ󥿤ɥХåեνޤ */
			len = (UINT)(cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf));
		else
			len = cep->sbufsz - cep->swbuf_count;

		/* ̿üΥå롣*/
		syscall(sig_sem(cep->semid_lock));

		if (len > 0) {

			/* tcp_get_buf γĹꤹ롣*/
			cep->get_buf_len = len;

			/* ɥХåեΥɥ쥹֤*/
			*cep->snd_p_buf = cep->sbuf_wptr;

			if (IS_PTR_DEFINED(cep->callback))
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)(UW)len);
			else
				syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CCEPID(cep));

			/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
			cep->snd_tskid = TA_NULL;
			cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
			}
		}

	else if (cep->snd_nblk_tfn == TFN_TCP_SND_DAT) {	/* Υ֥å󥰥 */
		ER_UINT	error;

	 	/* ɥХåե˥ǡ񤭹ࡣ*/
		error = TCP_WRITE_SWBUF(cep, cep->snd_data, (UINT)cep->snd_len);

		if (IS_PTR_DEFINED(cep->callback))
			(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)error);
		else
			syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CCEPID(cep));

		/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
		cep->snd_tskid = TA_NULL;
		cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
		}
	else {

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		/* ɥХåե˶褿ϥ򵯾롣*/
		if (last == cep->sbufsz && cep->swbuf_count < cep->sbufsz)
			syscall(set_flg(cep->snd_flgid, CEP_EVT_SWBUF_READY));

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	if (cep->swbuf_count > 0) {
		/* ɥХåե˥ǡнϤݥȤ롣*/
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}
	}

/*
 *  tcp_write_swbuf -- ɥХåե˥ǡ񤭹ࡣ
 */

ER_UINT
tcp_write_swbuf_ncs (T_TCP_CCEP *cep, VP data, UINT len)
{
	UINT	offset;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/* len ɥХåեζξܤǡˤ롣*/
	if (len > (cep->sbufsz - cep->swbuf_count))
		len = cep->sbufsz - cep->swbuf_count;

	/* 񤭹ߥݥ󥿤饦ɤȤν */
	if (len > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf)) {
		offset = (UINT)(cep->sbufsz - (cep->sbuf_wptr -(UB*)cep->sbuf));
		memcpy(cep->sbuf_wptr, data, (size_t)offset);
		cep->sbuf_wptr  = (UB*)cep->sbuf;
		cep->swbuf_count += offset;
		}
	else
		offset = 0;

	memcpy(cep->sbuf_wptr, (VP)((UB*)data + offset), (size_t)(len - offset));
	cep->sbuf_wptr  += len - offset;
	cep->swbuf_count += len - offset;

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return (ER_UINT)len;
	}

/*
 *  tcp_wait_swbuf -- ɥХåեΤԤġ
 */

ER
tcp_wait_swbuf_ncs (T_TCP_CCEP *cep, TMO tmout)
{
	ER	error;
	FLGPTN	flag;

	while (cep->swbuf_count >= cep->sbufsz) {
		/*
		 *  ɥХåեζʤСϤݥȤơ
		 *  ɥХåեޤԤġ
		 */
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);

		if ((error = twai_flg(cep->snd_flgid, CEP_EVT_SWBUF_READY, TWF_ORW, &flag, tmout)) != E_OK) {
			return error;
			}
		syscall(clr_flg(cep->snd_flgid, (FLGPTN)(~CEP_EVT_SWBUF_READY)));

		/*
		 *  Ǥ뤫CEP  FSM ֤򸫤롣
		 *  ɥХåեޤԤĴ֤ˡǽˤʤäϡ
		 *  ͥǤ줿Ȥ̣Ƥ롣
		 */
		if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
			return E_CLS;
			}
		}

	return E_OK;
	}
/*
 *  tcp_get_swbuf_addr -- ɥХåեζɥ쥹롣
 */

ER_UINT
tcp_get_swbuf_addr_ncs (T_TCP_CCEP *cep, VP *p_buf)
{
	UINT	len;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/* ɥХåեζɥ쥹Ƭꤹ롣*/
	*p_buf = cep->sbuf_wptr;

	/* ɥХåեζ׻롣*/
	if (cep->sbufsz - cep->swbuf_count > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf))
		/* ߥݥ󥿤饦ɤȤϡߥݥ󥿤ɥХåեνޤ */
		len = (UINT)(cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf));
	else
		len = cep->sbufsz - cep->swbuf_count;

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	/* ɥХåեζǡĹꤷ֤ͤ*/
	cep->get_buf_len = len;
	return (ER_UINT)len;
	}

/*
 *  tcp_send_swbuf -- ɥХåեΥǡǽˤ롣
 */

void
tcp_send_swbuf_ncs (T_TCP_CCEP *cep, UINT len)
{
	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	cep->sbuf_wptr  += len;
	cep->swbuf_count += len;

	/* ߥݥ󥿤饦ɤȤν */
	if (cep->sbuf_wptr >= (UB*)cep->sbuf + cep->sbufsz)
		cep->sbuf_wptr  = (UB*)cep->sbuf;

	/* tcp_get_buf γĹꥻåȤ롣*/
	cep->get_buf_len = 0;

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	/* ɥХåեեΤȤ϶Ū롣*/
	if (cep->swbuf_count >= cep->sbufsz)
		cep->flags |= CEP_FLG_FORCE | CEP_FLG_FORCE_CLEAR;
	}

/*
 *  tcp_is_swbuf_full -- ɥХåեդå롣
 */

BOOL
tcp_is_swbuf_full_ncs (T_TCP_CCEP *cep)
{
	return cep->swbuf_count >= cep->sbufsz;
	}

#endif	/* of #ifndef TCP_CFG_SWBUF_CSAVE_ONLY */

#ifndef TCP_CFG_RWBUF_CSAVE_ONLY

/*
 *  TCP ̿üμɥХåեξʥԡǽ̵
 */

/*
 *  tcp_drop_rwbuf -- ɥХåեꤵ줿ƥåʬ롣
 */

void
tcp_drop_rwbuf_ncs (T_TCP_CCEP *cep, UINT len)
{
	cep->rwbuf_count -= len;
	cep->rbuf_rptr  += len;

	/* ɤ߽Фݥ󥿤饦ɤȤν */
	if (cep->rbuf_rptr >= (UB*)cep->rbuf + cep->rbufsz)
		cep->rbuf_rptr  = (UB*)cep->rbuf;
	}

/*
 *  tcp_read_rwbuf -- ɥХåեꤵ줿ƥåʬɤ߽Ф
 */

UINT
tcp_read_rwbuf_ncs (T_TCP_CCEP *cep, VP data, UINT len)
{
	UINT	offset;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/* len ȼɥХåեΥǡξФǡˤ롣*/
	if (len > cep->rwbuf_count)
		len = cep->rwbuf_count;

	/* ɤ߽Фݥ󥿤饦ɤȤν */
	if (len > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf)) {
		offset = (UINT)(cep->rbufsz - (cep->rbuf_rptr -(UB*)cep->rbuf));
		memcpy(data, cep->rbuf_rptr, (size_t)offset);
		cep->rwbuf_count -= offset;
		cep->rbuf_rptr   = (UB*)cep->rbuf;
		}
	else
		offset = 0;

	memcpy((VP)((UB*)data + offset), cep->rbuf_rptr, (size_t)(len - offset));
	cep->rwbuf_count -= len - offset;
	cep->rbuf_rptr  += len - offset;

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return len;
	}

/*
 *  tcp_get_rwbuf_addr -- ɥХåեζɥ쥹롣
 */

UINT
tcp_get_rwbuf_addr_ncs (T_TCP_CCEP *cep, VP *p_buf)
{
	UINT	len;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/* ɥХåեΥǡĹ׻롣*/
	if (cep->rwbuf_count > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf))
		/* ݥ󥿤饦ɤȤϼɥХåեνޤ */
		len = (UINT)(cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf));
	else
		len = cep->rwbuf_count;

	/* ɥХåեΥǡΥɥ쥹Ƭꤹ롣*/
	*p_buf = cep->rbuf_rptr;

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	/* ɥХåեΥǡĹꤷ֤ͤ*/
	cep->rcv_buf_len = len;
	return len;
	}

/*
 *  tcp_write_rwbuf -- ɥХåե˥ǡ񤭹ࡣ
 *
 *    :
 *	 input ϡT_TCP_Q_HDR ˤ󥯤졢
 *	¤ؤλƤʤФʤʤޤ
 *	ɲäǡϡɥХåե˼ޤ뤳ȡ
 */

void
tcp_write_rwbuf_ncs (T_TCP_CCEP *cep, T_NET_BUF *input, UINT thoff)
{
	T_TCP_Q_HDR	*qhdr;
	UINT		offset, inlen, last;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	qhdr  = (T_TCP_Q_HDR*)GET_TCP_HDR(input, thoff);

	/* Ѥߥֹ򹹿롣*/
	cep->rcv_nxt += qhdr->slen;

	last  = cep->rwbuf_count;
	inlen = qhdr->slen;

	/*
	 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
	 *  ϡץꥱˡ꤫餳ʾǡ
	 *  ʤȤΤ餻뤿Ǥ롣
	 */
	if (inlen > 0) {

		/* 񤭹ߥݥ󥿤饦ɤȤν */
		if (inlen > cep->rbufsz - (cep->rbuf_wptr - (UB*)cep->rbuf)) {
			offset = (UINT)(cep->rbufsz - (cep->rbuf_wptr - (UB*)cep->rbuf));
			memcpy(cep->rbuf_wptr, (VP)(GET_TCP_SDU(input, thoff) + qhdr->soff), (size_t)offset);
			cep->rbuf_wptr   = (UB*)cep->rbuf;
			cep->rwbuf_count += offset;
			inlen           -= offset;
			}
		else
			offset	= 0;

		memcpy(cep->rbuf_wptr, (VP)(GET_TCP_SDU(input, thoff) + qhdr->soff + offset), (size_t)inlen);
		cep->rbuf_wptr  += inlen;
		cep->rwbuf_count += inlen;

		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DATA_SEGS],   1);
		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DATA_OCTETS], inlen);
		}

	syscall(rel_net_buf(input));

#ifdef TCP_CFG_NON_BLOCKING

	if (cep->rcv_nblk_tfn == TFN_TCP_RCV_BUF) {	/* Υ֥å󥰥 */

		INT	len;

		/* ɥХåեζǡĹ׻롣*/
		if (cep->rwbuf_count > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf)) {
			/* ݥ󥿤饦ɤȤϼɥХåեνޤ */
			len = (UINT)(cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf));
			}
		else
			len = cep->rwbuf_count;

		/* ̿üΥå롣*/
		syscall(sig_sem(cep->semid_lock));

		/*
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if (len > 0 || inlen == 0) {

			/* tcp_rcv_buf γĹꤹ롣*/
			cep->rcv_buf_len = len;

			/* ɥХåեΥɥ쥹֤*/
			*cep->rcv_p_buf = cep->rbuf_rptr;


			if (IS_PTR_DEFINED(cep->callback))
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)len);
			else
				syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CCEPID(cep));

			if (len == 0) {

				/*
				 *  ̿üåơ
				 *  ɥХåե塼ΥͥåȥХåե롣
				 */
				syscall(wai_sem(cep->semid_lock));
				TCP_FREE_RWBUFQ(cep);
				syscall(sig_sem(cep->semid_lock));
				}
			}

		/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
		cep->rcv_tskid = TA_NULL;
		cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
		}

	else if (cep->rcv_nblk_tfn == TFN_TCP_RCV_DAT) {	/* Υ֥å󥰥 */
		ER_UINT	len;

		/* ̿üΥå롣*/
		syscall(sig_sem(cep->semid_lock));

		/* ɥХåեǡФ*/
		if ((len = TCP_READ_RWBUF(cep, cep->rcv_data, (UINT)cep->rcv_len)) > 0) {
			/* ˥ɥѤäȤΤ餻뤿ϤݥȤ롣*/
			cep->flags |= CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);
			}

		/*
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if (len > 0 || inlen == 0) {

			if (IS_PTR_DEFINED(cep->callback))
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)len);
			else
				syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CCEPID(cep));
			}

		/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
		cep->rcv_tskid = TA_NULL;
		cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;

		}
	else {

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		/* ̿üΥå롣*/
		syscall(sig_sem(cep->semid_lock));

		if (inlen == 0 && cep->rwbuf_count == 0) {
			/*
			 *  ɥХåեΥǡ 0 ǡ
			 *  ꤫ FIN ե饰դȤȤϡ
			 *  ̿üåơ
			 *  ɥХåե塼ΥͥåȥХåե롣
			 */
			syscall(wai_sem(cep->semid_lock));
			TCP_FREE_RWBUFQ(cep);
			syscall(sig_sem(cep->semid_lock));
			}

		/*
		 *  ɥХåե˥ǡ뤫 inlen == 0 λϥ򵯾롣
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if ((last == 0 && cep->rwbuf_count > 0) || inlen == 0)
			syscall(set_flg(cep->rcv_flgid, CEP_EVT_RWBUF_READY));

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	}

#endif	/* of #ifndef TCP_CFG_RWBUF_CSAVE_ONLY */

#endif	/* of #ifdef SUPPORT_TCP */
