/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: nd6_rtr.c,v 1.3 2006/02/07 10:11:18 abe Exp abe $
 */

/*	$FreeBSD: src/sys/netinet6/nd6_rtr.c,v 1.11 2002/04/19 04:46:23 suz Exp $	*/
/*	$KAME: nd6_rtr.c,v 1.111 2001/04/27 01:37:15 jinmei Exp $	*/

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet6/in6.h>
#include <netinet6/in6_var.h>
#include <netinet6/nd6.h>
#include <netinet6/in6_ifattach.h>
#include <netinet/ip6.h>
#include <netinet/icmp6.h>
#include <netinet6/ip6_var.h>

#include <net/if6_var.h>

#ifdef SUPPORT_INET6

#if NUM_ND6_DEF_RTR_ENTRY > 0

/*
 *  ǥեȥ롼ꥹ
 */

static T_DEF_ROUTER nd6_def_router[NUM_ND6_DEF_RTR_ENTRY];

/*
 *  ѿ
 */

SYSTIM	nd6_base_reachable_time		= ND6_DEF_REACHABLE_TIME;	/* 롼Τ줿		*/
SYSTIM	nd6_reachable_time		= ND6_DEF_REACHABLE_TIME;	/* 롼Τ줿ͤ	*/
SYSTIM	nd6_recalc_reachtm_interval	= ND6_RECALC_REACHTM_INTERVAL;	/* ãǽֺ֤ͭƷ׻ֳ	*/
SYSTIM	nd6_retrans_time		= ND6_DEF_RETRANS_TIME;		/* õֳ			*/
UB	ip6_defhlim			= IPV6_DEFHLIM;			/* ۥåץߥåȤε		*/

/*
 *  defrtrlist_update -- ǥեȥ롼ꥹȤ򹹿롣
 */

static int
defrtrlist_update (T_IN6_ADDR *src, UW lifetime, UB flags)
{
	T_DEF_ROUTER	*dr, *fdr = NULL;
	SYSTIM		now;
	int		ix;

	/* ϿѤĴ٤롣*/
	fdr = nd6_defrtrlist_lookup(src);

	/* ȥõ*/
	if (fdr == NULL) {
		for (ix = NUM_ND6_DEF_RTR_ENTRY; ix -- > 0; ) {
			dr = &nd6_def_router[ix];
			if (dr->state == ND6_DEF_RTR_FREE ||
			    IN6_ARE_ADDR_EQUAL(&dr->addr, src)) {
				fdr = dr;
				break;
				}
			}
		}

	syscall(get_tim(&now));

	/* ȥ꤬ʤС֤ͭûȥ롣*/
	if (fdr == NULL) {
		T_DEF_ROUTER	*sdr = NULL;
		W		diff, sdiff = 0xffffffff;

		syscall(wai_sem(SEM_ND6_DEFRTRLIST));
		for (ix = NUM_ND6_DEF_RTR_ENTRY; ix -- > 0; ) {
			dr = &nd6_def_router[ix];
			if (dr->state == ND6_DEF_RTR_FREE) {
				/* ȥ꤬Ĥǽ롣*/
				fdr = dr;
				break;
				}
			else {
				diff = (W)(dr->expire - now);
				if (diff <= 0) {	/* dr->expire <= now */
					/* ˡ֤ͭ᤮Ƥ롣*/
					fdr = dr;
					break;
					}
				else if (diff < sdiff)
					sdr = dr;
				}
			}
		if (sdr != NULL) {
			T_IN6_IFADDR	*ia;
			T_IFNET		*ifp = IF_GET_IFNET();

			fdr = sdr;
			if ((ia = in6ifa_ifpwithrtrix(ifp, fdr - nd6_def_router)) != NULL) {
				/*
				 *  ͥåȥ󥿥եΥץեåΤ
				 *  롼ãǽˤ롣
				 */
				ia->rtr_index = IN6_RTR_IX_UNREACH;
				}
			fdr->state = ND6_DEF_RTR_FREE;
			}
		syscall(sig_sem(SEM_ND6_DEFRTRLIST));
		}

	fdr->addr     = *src;
	fdr->lifetime = lifetime * SYSTIM_HZ;		/* lifetime ñ̤ */
	fdr->flags    = flags;
	fdr->expire   = now + fdr->lifetime;
	fdr->state    = ND6_DEF_RTR_BUSY;
	return fdr - nd6_def_router;
	}

/*
 *  in6_ifadd -- 󥿥ե˥ɥ쥹ɲä롣
 */

static ER
in6_ifadd (T_ND_OPT_PREFIX_INFO *pi, T_IN6_IFADDR *ia, int rtr_index)
{
	T_IN6_ADDR	mask, addr;
	T_IN6_IFADDR	*lla;
	T_IFNET		*ifp = IF_GET_IFNET();
	int		ix;

	lla = &ifp->in_ifaddrs[IPV6_IFADDR_IX_LINKLOCAL];

	/*
	 *  󥯥륢ɥ쥹̤ϿǤв⤷ʤ
	 */
	if ((lla->flags & IN6_IFF_DEFINED) == 0)
		return E_OBJ;

	/*
	 *  롼Τ줿ץեåĹ
	 *  󥯥륢ɥ쥹ΥץեåĹ
	 *  ۤʤäƤХ顼
	 */
	if (lla->prefix_len != pi->prefix_len)
		return E_PAR;

	/* ץեåޥ롣*/
	in6_plen2pmask(&mask, pi->prefix_len);

	/* ɥ쥹롣*/
	for (ix = 0; ix < 4; ix ++)
		addr.s6_addr32[ix] = (pi->prefix.s6_addr32[ix] &  mask.s6_addr32[ix])
		                   | ( lla->addr.s6_addr32[ix] & ~mask.s6_addr32[ix]);

	return in6_update_ifa(ifp, &addr, pi->prefix_len, ntohs(pi->valid),
	                      ntohs(pi->preferred), rtr_index, IN6_IFF_AUTOCONF);
	}

/*
 *  prelist_update -- ץեåꥹȤ򹹿롣
 */

static void
prelist_update (T_ND_OPT_PREFIX_INFO *pi, int ifa_index, int rtr_index)
{
	T_IN6_IFADDR	*ia;
	T_IFNET		*ifp = IF_GET_IFNET();

	if ((pi->flags & (ND_OPT_PI_FLAG_ONLINK | ND_OPT_PI_FLAG_AUTO)) !=
	                 (ND_OPT_PI_FLAG_ONLINK | ND_OPT_PI_FLAG_AUTO))
		/*
		 * 󥯥ե饰ȥơȥ쥹ɥ쥹ư꤬
		 * ꤵƤʤСʤ
		 */
		return;

	ia = &ifp->in_ifaddrs[ifa_index];

	if ((ia->flags & IN6_IFF_DEFINED) == 0) {
		/* ̤ϿΤȤϡin6_ifadd ƤӽФ*/
		in6_ifadd(pi, ia, rtr_index);
		}
	else if (ia->prefix_len != pi->prefix_len) {
		/*
		 * ץեåĹפʤйʤ
		 */
		;
		}
	else if ((ia->flags & IN6_IFF_AUTOCONF) == 0) {
		/*
		 *  ơȥ쥹ɥ쥹ưˤ
		 *  ꤵƤʤйʤ
		 */
		;
		}
	else if (ia->flags & IN6_IFF_TENTATIVE) {
		/*
		 *  ʣʤ鹹ʤ
		 */
		;
		}
	else if (ia->rtr_index == IN6_RTR_IX_UNREACH ||
	         ia->rtr_index == rtr_index) {
		/*
		 *  ͥåȥ󥿥եΥץեåΤ
		 *  롼ãǽˤʤäƤ뤫
		 *  롼Υǥåפй롣
		 */
		T_IN6_ADDR	mask, addr;
		T_IN6_IFADDR	*lla;
		T_IFNET		*ifp = IF_GET_IFNET();
		UW		vltime;
		SYSTIM		now;
		int		ix;

		/* ߤ֤ͭĴ٤롣*/
		syscall(get_tim(&now));
		now /= SYSTIM_HZ;

		if (ntohs(pi->valid) >= (2 * 60 * 60) || 
		   IFA6_IS_INVALID(ia, now)           ||
		   ntohs(pi->valid) >= (ia->lifetime.expire - now)) {
			/*
			 *  lifetime.expirepi->valid (ͭ) 
			 *  pi->preferred (侩ͭ) ñ̤ [s]
			 *  Τ줿֤ͭ 2 ְʾ夫ߤλĤ֤
			 *  ĹС֤ͭˤϡΤ줿֤ͭꤹ롣
			 */
			vltime = ntohs(pi->valid);
			}
		else {
			/*
			 *  IPsec ̤Τᡢ2 ֤ꤹ롣
			 */
			vltime = 2 * 60 * 60;
			}

		lla = &ifp->in_ifaddrs[IPV6_IFADDR_IX_LINKLOCAL];

		/* ץեåޥ롣*/
		in6_plen2pmask(&mask, pi->prefix_len);

		/* ɥ쥹롣*/
		for (ix = 0; ix < 4; ix ++)
			addr.s6_addr32[ix] = (pi->prefix.s6_addr32[ix] &  mask.s6_addr32[ix])
			                   | ( lla->addr.s6_addr32[ix] & ~mask.s6_addr32[ix]);

		in6_update_ifa(ifp, &addr, pi->prefix_len, vltime,
		               ntohs(pi->preferred), rtr_index, IN6_IFF_AUTOCONF | IN6_IFF_NODAD);
		}
	}

/*
 *  nd6_rs_output -- 롼Ϥ롣
 */

static void
nd6_rs_output (void)
{
	T_ROUTER_SOLICIT_HDR	*rsh;
	T_NET_BUF		*output;
	T_IN6_IFADDR		*ifa;
	T_IN6_ADDR		*saddr;
	UH			len;

	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_RS_OUT_PACKETS], 1);

	/*
	 *  ɥ쥹ˤϡ󥯥륢ɥ쥹ꤹ뤬
	 *  ޤꤵ줤ʤС̵ꤹ롣
	 */
	if ((ifa = in6ifa_ifpwithix(IF_GET_IFNET(), IPV6_IFADDR_IX_LINKLOCAL)) != NULL && !IFA6_IS_NOTREADY(ifa))
		saddr = &ifa->addr;
	else
		saddr = &in6_addr_unspecified;

	len = (ROUTER_SOLICIT_HDR_SIZE + 7) >> 3 << 3;

	/* ͥåȥХåեIPv6 إåꤹ롣*/
	if (in6_get_datagram(&output, len, 0, &in6_addr_linklocal_allrouters,
	                     saddr, IPPROTO_ICMPV6,
	                     IPV6_MAXHLIM, NBA_SEARCH_ASCENT, TMO_ND6_RS_OUTPUT) != E_OK)
		return;

 	/* 롼إåꤹ롣*/
 	rsh = GET_ROUTER_SOLICIT_HDR(output, IF_IP6_ROUTER_SOLICIT_HDR_OFFSET);
 	rsh->hdr.type       = ND_ROUTER_SOLICIT;
 	rsh->hdr.code       = 0;
 	rsh->nd_rs_reserved = 0;

	/* å׻롣*/
	rsh->hdr.sum = 0;
	rsh->hdr.sum = in6_cksum(output, IPPROTO_ICMPV6, (UB*)rsh - output->buf, len);

	/* 롣*/
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_OUT_OCTETS],
	               output->len - GET_IF_IP6_HDR_SIZE(output));
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_OUT_PACKETS], 1);
	NET_COUNT_MIB(icmp6_ifstat.ipv6IfIcmpOutMsgs, 1);
	NET_COUNT_MIB(icmp6_ifstat.ipv6IfIcmpOutRouterSolicits, 1);
	ip6_output(output, IPV6_OUT_SET_HOP_LIMIT(IPV6_OUT_FLG_HOP_LIMIT, IPV6_MAXHLIM), TMO_ND6_RS_OUTPUT);
	}

/*
 *  nd6_defrtrlist_lookup -- ǥեȥ롼ꥹȤõ롣
 */

T_DEF_ROUTER *
nd6_defrtrlist_lookup (T_IN6_ADDR *src)
{
	T_DEF_ROUTER	*dr = NULL;
	int		ix;

	for (ix = NUM_ND6_DEF_RTR_ENTRY; ix -- > 0; ) {
		dr = &nd6_def_router[ix];
		if (dr->state != ND6_DEF_RTR_FREE && IN6_ARE_ADDR_EQUAL(&dr->addr, src))
			return dr;
		}
	return NULL;
	}

/*
 *  nd6_router_lookup -- ɥ쥹顢Ŭڤʥ롼Υɥ쥹֤
 *
 *    : ɥ쥹ϡȥ륢ɥ쥹ȽǽʥХ˥ɥ쥹
 *          ΤбƤ롣
 */

T_IN6_ADDR *
nd6_router_lookup (T_IFNET *ifp, T_IN6_ADDR *dst)
{
	T_IN6_IFADDR	*ifa;
	T_IN6_ADDR	*gw = NULL;
	T_DEF_ROUTER	*dr;
	int		ix;

	/* ɥ쥹Ʊ쥹פΥץեåΤ롼õ*/
	for (ix = NUM_ND6_DEF_RTR_ENTRY; ix -- > 0; ) {
		dr = &nd6_def_router[ix];
		if (dr->state != ND6_DEF_RTR_FREE && (ifa = in6ifa_ifpwithrtrix(ifp, ix)) != NULL) {
			if ((IN6_IS_ADDR_SITELOCAL(dst)         && IN6_IS_ADDR_SITELOCAL(&ifa->addr)) ||
			    (IN6_IS_ADDR_AGGREGATE_UNICAST(dst) && IN6_IS_ADDR_AGGREGATE_UNICAST(&ifa->addr)))
				gw = &dr->addr;
			}
		}

	/* ĤʤȤϡͭʥ롼õ*/
	if (gw == NULL) {
		for (ix = NUM_ND6_DEF_RTR_ENTRY; ix -- > 0; ) {
			dr = &nd6_def_router[ix];
			if (dr->state != ND6_DEF_RTR_FREE)
				gw = &dr->addr;
			}
		}

	return gw;
	}

/*
 *  nd6_defrtrlist_timer -- ǥեȥ롼ꥹȤδޡ
 */

void
nd6_defrtrlist_timer (void)
{
	T_IN6_IFADDR	*ia;
	T_IFNET		*ifp = IF_GET_IFNET();
	T_DEF_ROUTER	*dr;
	SYSTIM		now;
	int		ix;

	syscall(get_tim(&now));
	syscall(wai_sem(SEM_ND6_DEFRTRLIST));
	for (ix = NUM_ND6_DEF_RTR_ENTRY; ix -- > 0; ) {
		dr = &nd6_def_router[ix];
		if (dr->state != ND6_DEF_RTR_FREE && (W)(dr->expire - now) <= 0) {
		                                        /* dr->expire <= now */
			if ((ia = in6ifa_ifpwithrtrix(ifp, ix)) != NULL) {
				/*
				 *  ͥåȥ󥿥եΥץեåΤ
				 *  롼ãǽˤ롣
				 */
				ia->rtr_index = IN6_RTR_IX_UNREACH;
				}
			dr->state = ND6_DEF_RTR_FREE;
			}
		}
	syscall(sig_sem(SEM_ND6_DEFRTRLIST));
	}

/*
 *  nd6_get_drl -- ǥեȥ롼ꥹȤ롣
 */

const T_DEF_ROUTER *
nd6_get_drl (void)
{
	return nd6_def_router;
	}

#endif	/* of #if NUM_ND6_DEF_RTR_ENTRY > 0 */

/*
 *  nd6_ra_input -- 롼ΤϽ
 */

void
nd6_ra_input (T_NET_BUF *input, UINT off)
{
#if NUM_ND6_DEF_RTR_ENTRY > 0

	T_IP6_HDR		*ip6h;
	T_ROUTER_ADVERT_HDR	*rah;
	SYSTIM			now;
	int			rix;
	UW			advrea;
	UB			nd_opt_off[ND_OPT_OFF_ARRAY_SIZE];

	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_RA_IN_PACKETS], 1);

	ip6h = GET_IP6_HDR(input);

	/*
	 *  إåΥåʲξ˴롣
	 *    ۥåץߥåȤ IPV6_MAXHLIM (255) ʳ
	 *    إåĹû
	 *    ɥ쥹󥯥ǤϤʤ (RFC2461)
	 */
	if (ip6h->hlim != IPV6_MAXHLIM                ||
	    input->len - off < ROUTER_ADVERT_HDR_SIZE ||
	    !IN6_IS_ADDR_LINKLOCAL(&ip6h->src))
		goto err_ret;

	rah  = GET_ROUTER_ADVERT_HDR(input, off);

	/* õץΥեåȤϿ롣*/
	if (nd6_options(nd_opt_off, input->buf + (off + ROUTER_ADVERT_HDR_SIZE),
	                            input->len - (off + ROUTER_ADVERT_HDR_SIZE)) != E_OK)
		goto err_ret;
	/*
	 *  ãǽ֤֤ͭι
	 */
	if (rah->reachable) {
		advrea = ntohl(rah->reachable) * SYSTIM_HZ / 1000;	/* rah->reachable ñ̤ ms */
		if (advrea <= ND6_MAX_REACHABLE_TIME &&
		    advrea != nd6_base_reachable_time) {
			syscall(get_tim(&now));
			nd6_recalc_reachtm_interval
				= now + ND6_RECALC_REACHTM_INTERVAL;
			nd6_base_reachable_time	= advrea;
			nd6_reachable_time
				= ND6_CALC_REACH_TIME(nd6_base_reachable_time);
			}
		}

	/* õֳ֤ι */
	if (rah->retransmit) {
		nd6_retrans_time = ntohs(rah->retransmit) * SYSTIM_HZ / 1000;
									/* rah->retransmit ñ̤ ms */
		}

	/* ۥåץߥåȤεͤι */
	if (rah->nd_ra_current_hoplimit) {
		ip6_defhlim = rah->nd_ra_current_hoplimit;
		}

	/* ǥեȥ롼ꥹȤι */
	rix = defrtrlist_update(&ip6h->src,
	                       ntohl(rah->nd_ra_router_lifetime),
	                       rah->nd_ra_flags);		/* rah->nd_ra_router_lifetime ñ̤ */

	if (nd_opt_off[ND_OPT_OFF_ARRAY_IX(ND_OPT_PREFIX_INFO_COUNT)]) {
		T_ND_OPT_PREFIX_INFO	*pi;
		UINT			pi_off, pi_count;
		int			ix;

		pi_count = nd_opt_off[ND_OPT_OFF_ARRAY_IX(ND_OPT_PREFIX_INFO_COUNT)];
		pi_off   = off + ROUTER_ADVERT_HDR_SIZE
		               + nd_opt_off[ND_OPT_OFF_ARRAY_IX(ND_OPT_PREFIX_INFORMATION)] - 8;
	 	/* : ץ󥪥եåˤϡեå + 8 ꤵƤ롣*/
		while (pi_count -- > 0) {
			pi = (T_ND_OPT_PREFIX_INFO*)(input->buf + pi_off);
			if (pi->type != ND_OPT_PREFIX_INFORMATION)
				/* ץ󥿥פץեåǤʤв⤷ʤ*/
				;
			else if (pi->len != 4)
			    	/* ץեåĹ 32 (84) Ǥʤ */
				syslog(LOG_NOTICE, "[ND6 RTR] prefix opt len: %d.", pi->len);
			else if (pi->prefix_len > 128)
				/* ץեåĹ 128 ӥåȰʲ */
				syslog(LOG_NOTICE, "[ND6 RTR] prefix len: %d.", pi->prefix_len);
			else if (!(((ix = in6_addr2ifaix(&pi->prefix)) == IPV6_IFADDR_IX_SITELOCAL) ||
	                            (ix                                == IPV6_IFADDR_IX_GLOBAL)))
				/* ȥȽǽ˥㥹Ȱʳ */
				syslog(LOG_NOTICE, "[ND6 RTR] invalid addr: %s from %s.",
				                   ipv62str(NULL, &pi->prefix), ipv62str(NULL, &ip6h->src));
			else if (IN6_IS_ADDR_AGGREGATE_UNICAST(&pi->prefix) &&		
			         (pi->prefix_len != 64)                       )
				/* ǽ˥㥹ȤǡץեåĹ 64 ӥåȰʳ */
				syslog(LOG_NOTICE, "[ND6 RTR] invalid prefix len for global: %d.", pi->prefix_len);
			else if (ntohs(pi->preferred) > ntohs(pi->valid))
				/* 侩֤֤ͭͭĹ */
				syslog(LOG_NOTICE, "[ND6 RTR] preferred > valid time");
			else {
				syslog(LOG_NOTICE, "[ND6 RTR] update prefix: %s from %s.",
				                   ipv62str(NULL, &pi->prefix), ipv62str(NULL, &ip6h->src));
				prelist_update(pi, ix, rix);	/* ץեåꥹȤ򹹿롣*/
				}
			pi_off += pi->len << 3;		/* ץĹñ̤ 8 Х */
			}
		}

	syscall(rel_net_buf(input));
	return;

err_ret:
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_IN_ERR_PACKETS], 1);
	syscall(rel_net_buf(input));

#else	/* of #if NUM_ND6_DEF_RTR_ENTRY > 0 */

	/*
	 *  롼Τʤϡ˴ƽλ롣
	 */
	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_RA_IN_PACKETS], 1);
	syscall(rel_net_buf(input));

#endif	/* of #if NUM_ND6_DEF_RTR_ENTRY > 0 */
	}

#if NUM_ND6_RTR_SOL_RETRY > 0

/*
 *  nd6_rtrsol_ctl -- 롼Ϥ
 */

void
nd6_rtrsol_ctl (void)
{
	T_IN6_IFADDR	*ifa;
	int		try, ix;

	/* 󥯥륢ɥ쥹Υɥ쥹롣*/
	if ((ifa = in6ifa_ifpwithix(IF_GET_IFNET(), IPV6_IFADDR_IX_LINKLOCAL)) == NULL)
		return;

	/* 󥯥륢ɥ쥹νʣнλԤġ*/
	do {
		/* 󥯥륢ɥ쥹νʣнλԤ֤ꤹ롣*/
		syscall(dly_tsk(net_rand() % TMO_ND6_RTR_SOL_DELAY));

		/* ԤäƤ֤˽ʣФ줿齪λ롣*/
		if (ifa->flags & IN6_IFF_DUPLICATED)
			return;

		} while (!((ifa->flags & IN6_IFF_DEFINED) && (ifa->flags & IN6_IFF_TENTATIVE) == 0));

	for (try = 0; try < NUM_ND6_RTR_SOL_RETRY; try ++) {

		/* ǥեȥ롼ꥹȤ˥ȥ꤬нλ */
		for (ix = NUM_ND6_DEF_RTR_ENTRY; ix -- > 0; ) {
			if (nd6_def_router[ix].state != ND6_DEF_RTR_FREE)
				return;
			}

		/* 롼Ϥ롣*/
		nd6_rs_output();

		/* Ϥ 2 ܰʹߤٱ֤ꤹ롣*/
		syscall(dly_tsk(TMO_ND6_RTR_SOL_INTERVAL));
		}
	}

#endif	/* of #if NUM_ND6_RTR_SOL_RETRY > 0 */

#endif /* of #ifdef SUPPORT_INET6 */
